/***************************************************************************
 *	cd_menu.c - ȥå˥塼Ϣ
 *
 *				1994/5/1 --
 *
 *					Programmed by Nobuyuki Maruichi
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#ifdef	TOWNS
# include <linux/towns_cdioc.h>
#else
# include "towns_cdda.h"
#endif	/* TOWNS */

/***********************************************
 *	X Toolkit δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

/*****************************************
 * Atena Widget Υ󥯥롼ɡե
 *****************************************/
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Label.h>
#ifdef	X11R5
# include <X11/Xaw/Xawi18n.h>
# include <X11/Xaw/XawIm.h>
#endif	/*X11R5*/

/**************************************
 * mwxcd ѤΥ󥯥롼ɡե
 **************************************/
#include "cdda_ioc.h"
#include "cdda_ext.h"
#include "mwxcd.h"

#define CD_MENUS	CdMenus
#define CD_TRACKS	app_data.menu_panes
#define MAX_TRACKS	100

/***************************************************************************
 *	Хѿ
 *		ãĥ˥塼ѥȡ
 *			pressme: 		˥塼ƤӽФޥɡå
 *			cdshell[]: 		ãĥ˥塼Υ롦å
 *			menubox[]: 		ãĥ˥塼Υܥåå
 *			menulabel[]: 	ãĥ˥塼Υ٥롦å
 *			nextmenu[]: 	Σãĥ˥塼ƤӽФޥɡå
 *			menupane[]: 	ãĥ˥塼Υ˥塼
 *		¾
 *			disp_cd_menu_num: 	ɽΥ˥塼οݣ
 *			TrackType[]: 		ǡȥåǥȥå
 *
 ***************************************************************************/
Widget *cdshell, pressme;
Widget *menubox, *menulabel; 
Widget *nextmenu, menupane[MAX_TRACKS];

extern AppData app_data;
int CdMenus = 5;

int disp_cd_menu_num = -1;
/*char label_buffer[256];*/
const char *TrackType[] = {"Audio Track", "Data Track", NULL};
struct cd_time cd_time;
long int cd_frames;
Dimension menu_borderWidth, menu_width;
int MaxTracks;

extern struct cdda_play Cdda_info;
extern struct cd_toc CddaToc;
long int track_time(int track, const struct cd_toc *toc);
extern CddaDataForm *CurrentDisc_ptr;
extern int CurrentDiscFlag;

/***************************************************************************
 *	PlaceMenu: ɥåץ󡦥ȥå˥塼֤
 *	
 *		void PlaceMenu(w, client_data, call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PlaceMenu(Widget w, XtPointer client_data, XtPointer call_data)
{
	Position x, y;
	Dimension height;

	/*
	 *	pressme åȤ root window θɸΰ֤
	 */
	XtTranslateCoords(pressme, 	/* Widget */
		(Position) 0, 			/* x */
		(Position) 0, 			/* y */
		&x, &y); 				/* coords on root window */

	/* get height of cmenupressme so that menu is positioned below */
	XtVaGetValues(pressme, XtNheight, &height, NULL);

	/* move popup shell one pixel above and left of this position 
	 * (it's not visible yet) */
	XtVaSetValues(cdshell[0], 
			XtNx, x - 1,
			XtNy, y + height + 2,
			NULL);
	disp_cd_menu_num = 0;
}

/***************************************************************************
 *	CheckRightAndPopupCdmenu:  ɡ˥塼ɽ
 *	
 *		static int CheckRightAndPopupCdmenu(Widget w, XEvent *event, 
 *				String *params, Cardinal *num_params, Widget next_cd_menu);
 *	
 *		Widget w;				Υ˥塼ƤӽФå
 *		XEvent *event;			LeaveNotify ٥
 *		String *params;			̤
 *		Cardinal *num_params;	̤
 *		Widget next_cd_menu;	Υ˥塼
 *	֤
 *		
 *	
 *		裱 w åȤαü鳰˽ФȤ裵 
 *		next_cd_menu Υ˥塼ɽ
 *		
 ***************************************************************************/
/*ARGSUSED*/
static int CheckRightAndPopupCdmenu(Widget w, XEvent *event, 
				String *params, Cardinal *num_params, Widget next_cd_menu)
{
	int status = FALSE;
	XLeaveWindowEvent *leave_event = (XLeaveWindowEvent *) event;
	Dimension width, height;

	XtVaGetValues(w, 
			XtNheight, &height,
			XtNwidth, &width,
			NULL);

	if ((leave_event->x > 0) && (leave_event->y > 0) 
				&& (leave_event->y < height)) {
		/*
		 *	Next Tracks۹ܤαü鱦إɥγ
		 *	ݥ󥿤ФȤνФȤΥݥ󥿤κɸ
		 *	˼Υȥå˥塼ΰ֤ꤹ롣
		 */
		XtVaSetValues(next_cd_menu, 
				XtNx, leave_event->x_root - width / 2,
				XtNy, leave_event->y_root - 12,
				NULL);
		XtPopup(next_cd_menu, XtGrabExclusive);
		status = TRUE;
	}
	return(status);
}

/***************************************************************************
 *	CheckRightAndPopupSubmenu1: ɡ˥塼ɽ
 *	
 *		void CheckRightAndPopupSubmenu1(Widget w, XEvent *event, 
 *									String *params, Cardinal *num_params);
 *	
 *		Widget w;				Υ˥塼ƤӽФå
 *		XEvent *event;			LeaveNotify ٥
 *		String *params;			̤
 *		Cardinal *num_params;	̤
 *	֤
 *		
 *	
 *		裱 w åȤαü鳰˽ФȤcdshell[1] 
 *		subshell1ˤΥ˥塼ɽ
 *		
 ***************************************************************************/
/*ARGSUSED*/
void CheckRightAndPopupSubmenu1(Widget w, XEvent *event, 
									String *params, Cardinal *num_params)

{
	if(disp_cd_menu_num == 0) {
		if(CheckRightAndPopupCdmenu(w, event, 
					params, num_params, cdshell[1])) {
			disp_cd_menu_num = 1;
		}
	}
}

/***************************************************************************
 *	CheckRightAndPopupSubmenu2: ɡ˥塼ɽ
 *	
 *		static void CheckRightAndPopupSubmenu2(Widget w, XEvent *event, 
 *									String *params, Cardinal *num_params);
 *	
 *		Widget w;				Υ˥塼ƤӽФå
 *		XEvent *event;			LeaveNotify ٥
 *		String *params;			̤
 *		Cardinal *num_params;	̤
 *	֤
 *		
 *	
 *		裱 w åȤαü鳰˽ФȤcdshell[2] 
 *		subshell2ˤΥ˥塼ɽ
 *		
 ***************************************************************************/
/*ARGSUSED*/
void CheckRightAndPopupSubmenu2(Widget w, XEvent *event, String *params, Cardinal *num_params)
{
	if(disp_cd_menu_num == 1) {
		if(CheckRightAndPopupCdmenu(w, event, 
					params, num_params, cdshell[2])) {
			disp_cd_menu_num = 2;
		}
	}
}

/***************************************************************************
 *	CheckRightAndPopupSubmenu3: ɡ˥塼ɽ
 *	
 *		static void CheckRightAndPopupSubmenu3(Widget w, XEvent *event, 
 *									String *params, Cardinal *num_params);
 *	
 *		Widget w;				Υ˥塼ƤӽФå
 *		XEvent *event;			LeaveNotify ٥
 *		String *params;			̤
 *		Cardinal *num_params;	̤
 *	֤
 *		
 *	
 *		裱 w åȤαü鳰˽ФȤcdshell[3] 
 *		subshell3ˤΥ˥塼ɽ
 *		
 ***************************************************************************/
/*ARGSUSED*/
void CheckRightAndPopupSubmenu3(Widget w, XEvent *event, String *params, Cardinal *num_params)
{
	if(disp_cd_menu_num == 2) {
		if(CheckRightAndPopupCdmenu(w, event, 
					params, num_params, cdshell[3])) {
			disp_cd_menu_num = 3;
		}
	}
}

/***************************************************************************
 *	CheckRightAndPopupSubmenu4: ɡ˥塼ɽ
 *	
 *		static void CheckRightAndPopupSubmenu4(Widget w, XEvent *event, 
 *									String *params, Cardinal *num_params);
 *	
 *		Widget w;				Υ˥塼ƤӽФå
 *		XEvent *event;			LeaveNotify ٥
 *		String *params;			̤
 *		Cardinal *num_params;	̤
 *	֤
 *		
 *	
 *		裱 w åȤαü鳰˽ФȤcdshell[4] 
 *		subshell4ˤΥ˥塼ɽ
 *		
 ***************************************************************************/
/*ARGSUSED*/
void CheckRightAndPopupSubmenu4(Widget w, XEvent *event, String *params, Cardinal *num_params)
{
	if(disp_cd_menu_num == 3) {
		if(CheckRightAndPopupCdmenu(w, event, 
					params, num_params, cdshell[4])) {
			disp_cd_menu_num = 4;
		}
	}
}

/***************************************************************************
 *	isLeaveLeft: åȤκü鳰˽Фɤå
 *	
 *		int isLeaveLeft(Widget w, XEvent *event);
 *	
 *		Widget w;			ݥ󥿤ɥ⤫Υ줿å
 *		XEvent *event;		LeaveNotify ٥
 *	֤
 *		
 *	
 *		ݥ󥿤裱 w åȤκüü鳰˽Ф
 *		ɤå롣
 *		Υåϥɡ˥塼ݥåס󤹤뤫ɤ
 *		롣
 *		
 ***************************************************************************/
int isLeaveLeft(Widget w, XEvent *event)
{
	XLeaveWindowEvent *leave_event = (XLeaveWindowEvent *) event;
	Dimension height;

	XtVaGetValues(w, XtNheight, &height, NULL);
	return((leave_event->x < 0) && 
		(leave_event->y > 0)  && (leave_event->y < height));
}

/***************************************************************************
 *	PopdownSubmenu1: ȥå˥塼ݥåץ󤹤
 *	
 *		void PopdownSubmenu1(Widget w, XEvent *event, 
 *						String *params, Cardinal *num_params);
 *	
 *		Widget w;				
 *		XEvent *event;			
 *		String *params;			
 *		Cardinal *num_params;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopdownSubmenu1(Widget w, XEvent *event, String *params, Cardinal *num_params)
{
	if(isLeaveLeft(w, event)) {
		popdownTrackMenus(1);
	}
}

/***************************************************************************
 *	PopdownSubmenu2: ȥå˥塼ݥåץ󤹤
 *	
 *		void PopdownSubmenu2(Widget w, XEvent *event, 
 *							String *params, Cardinal *num_params);
 *	
 *		Widget w;
 *		XEvent *event;
 *		String *params;
 *		Cardinal *num_params;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopdownSubmenu2(Widget w, XEvent *event, String *params, Cardinal *num_params)
{
	if(isLeaveLeft(w, event)) {
		popdownTrackMenus(2);
	}
}

/***************************************************************************
 *	PopdownSubmenu3: ȥå˥塼ݥåץ󤹤
 *	
 *		void PopdownSubmenu3(Widget w, XEvent *event, 
 *							String *params, Cardinal *num_params);
 *	
 *		Widget w;
 *		XEvent *event;
 *		String *params;
 *		Cardinal *num_params;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopdownSubmenu3(Widget w, XEvent *event, String *params, Cardinal *num_params)
{
	if(isLeaveLeft(w, event)) {
		popdownTrackMenus(3);
	}
}

/***************************************************************************
 *	PopdownSubmenu4: ȥå˥塼ݥåץ󤹤
 *	
 *		void PopdownSubmenu4(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;
 *		XEvent *event;
 *		String *params;
 *		Cardinal *num_params;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopdownSubmenu4(Widget w, XEvent *event, String *params, Cardinal *num_params)
{
	if(isLeaveLeft(w, event)) {
		popdownTrackMenus(4);
	}
}

/***************************************************************************
 *	popdownTrackMenus: ɽƤȥå˥塼ݥåץ󤹤
 *	
 *		void popdownTrackMenus(int menu_no);
 *	
 *		int menu_no;	ݥåץ󤹤ǾΥ˥塼ֹ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void popdownTrackMenus(int menu_no)
{
	int shell_counter;

	for(shell_counter = disp_cd_menu_num;
				shell_counter >= menu_no;--shell_counter) {
		XtPopdown(cdshell[shell_counter]);
	}
	disp_cd_menu_num = shell_counter;
}

#define	track_string(track_counter)	\
	((CurrentDiscFlag != FALSE && app_data.menu_song_title != FALSE)?\
			((CurrentDisc_ptr->track_ptr + track_counter)->trackTitle):\
				(TrackType[isDataTrack(&toc->track[track_counter])]))

/***************************************************************************
 *	make_cd_menu: ȥå˥塼򹹿ޤ
 *	
 *		void make_cd_menu(struct cd_toc *toc);
 *	
 *		struct cd_toc *toc;		ãľTOC:Table Of Contents
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void make_cd_menu(struct cd_toc *toc)
{ 
	int track_counter, itrack, menu_counter;
	int tracks, menus;
	int cd_menu_top, cd_menu_bottom;
	Dimension height, inner_height, border_width;
	char label_buffer[100];

	tracks = NumberOfTrack(toc);
	if(tracks > 100)
		tracks = 100;
	
	menus = (tracks / CD_TRACKS) + ((tracks % CD_TRACKS) != 0);
	
	for(menu_counter = 0, track_counter = 0;
				track_counter < tracks;++menu_counter) {
		height = 0;
		XtVaGetValues(menulabel[menu_counter], 
				XtNheight, &inner_height, 
				XtNwidth, &menu_width, 
				XtNborderWidth, &border_width, NULL);
		height = inner_height + border_width * 2;
		cd_menu_top = CD_TRACKS * menu_counter + 1;
		cd_menu_bottom = ((tracks > (cd_menu_top + CD_TRACKS - 1))?
							(cd_menu_top + CD_TRACKS - 1):(tracks));
		sprintf(label_buffer, "CD Track Menu %d (Track %d -- %d)", 
			menu_counter + 1, CD_TRACKS * menu_counter + 1, cd_menu_bottom);
#ifdef	DEBUG
		printf("MENU LABEL:\"%s\"\n", label_buffer);
		fflush(stdout);
#endif	/*DEBUG*/
		if(menu_counter < CD_MENUS -1) {
			XtSetSensitive(nextmenu[menu_counter], 
					((menu_counter < menus -1)?(True):(False)));
			XtVaGetValues(nextmenu[menu_counter], 
						XtNheight, &inner_height, 
						XtNborderWidth, &border_width, NULL);
			XtVaSetValues(menulabel[menu_counter], 
						XtNlabel, label_buffer, 
						XtNwidth, menu_width, NULL);
			height += inner_height + border_width * 2;
		}
		for (itrack = 0;itrack < CD_TRACKS && track_counter < tracks;
										++itrack, ++track_counter) {
			/*
			 *      Make Label
			 */
			cd_frames = 
				track_time(track_counter + toc->s_track, toc);
			if(cd_frames != EOF) {
				frame2time(cd_frames, &cd_time);
				sprintf(label_buffer, "%3d.   %2d'%02d.%02d   %s   ",
					track_counter + toc->s_track, 
					cd_time.minute, cd_time.second, cd_time.frame, 
					track_string(track_counter));
#ifdef	DEBUG
				printf("MENU PANE%d:\"%s\"\n", track_counter, label_buffer);
				fflush(stdout);
#endif	/*DEBUG*/
				XtVaGetValues(menupane[track_counter], 
							XtNheight, &inner_height, 
							XtNwidth, &menu_width, 
							XtNborderWidth, &border_width, NULL);
				XtVaSetValues(menupane[track_counter], 
							XtNlabel, cdljc(label_buffer), 
								XtNwidth, menu_width, NULL);
			}
			XtVaGetValues(menupane[track_counter], 
						XtNheight, &inner_height, 
						XtNborderWidth, &border_width, NULL);
			height += inner_height + border_width * 2;
		}
		XtVaSetValues(cdshell[menu_counter], XtNheight, height, NULL);
	}
#ifdef	DEBUG
	printf("Make MENU End.\n", label_buffer);
	fflush(stdout);
#endif	/*DEBUG*/
}

/***************************************************************************
 *	cdmenu_init: ȥå˥塼ν
 *	
 *		void cdmenu_init(XtAppContext app_context, Widget box);
 *	
 *		XtAppContext app_context;	ץꥱ󡦥ƥ
 *		Widget box;					ƤΥå
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void cdmenu_init(XtAppContext app_context, Widget box)
{
	int track_counter, menu_counter;
	int tracks = 100;
	String shellprefix[2] = {"p", "sub"};
	String shellclassformat[] = {"%sshell", "%sshell%d"};
	char widget_name_buffer[256], buffer[50];
	String widget_name = widget_name_buffer, buf = buffer;
	int itrack;
	extern int TrackNumbers[];
	static XtActionsRec trial_actions[] = {
		{"checkRightAndPopupSubmenu1", CheckRightAndPopupSubmenu1},
		{"checkRightAndPopupSubmenu2", CheckRightAndPopupSubmenu2},
		{"checkRightAndPopupSubmenu3", CheckRightAndPopupSubmenu3},
		{"checkRightAndPopupSubmenu4", CheckRightAndPopupSubmenu4},
		{"popdownSubmenu1", PopdownSubmenu1},
		{"popdownSubmenu2", PopdownSubmenu2},
		{"popdownSubmenu3", PopdownSubmenu3},
		{"popdownSubmenu4", PopdownSubmenu4},
		{"flashControl", FlashControl},
		/*{"resizeConfig", ResizeConfig},*/
	};

	CdMenus = MAX_TRACKS / app_data.menu_panes + (MAX_TRACKS % app_data.menu_panes != 0);
	cdshell   = malloc(sizeof(Widget) * CdMenus); 
	menubox   = malloc(sizeof(Widget) * CdMenus);
	menulabel = malloc(sizeof(Widget) * CdMenus);
	nextmenu  = malloc(sizeof(Widget) * CdMenus);

	if(cdshell == NULL || menubox == NULL || menulabel == NULL || nextmenu == NULL) {
		return;
	}

	pressme = XtCreateManagedWidget(
		"pressme", 			/* widget name   */
		commandWidgetClass, /* widget class */
		box, 				/* parent widget*/
		NULL, 				/* argument list*/
		0 					/* arglist size */
		);

	for(menu_counter = 0, track_counter = 0;
				track_counter < tracks;++menu_counter) {
		sprintf(widget_name, shellclassformat[menu_counter != 0], 
					shellprefix[menu_counter != 0], menu_counter);
		cdshell[menu_counter] = 
			XtCreatePopupShell(widget_name,
								transientShellWidgetClass, pressme, NULL, 0);
		sprintf(widget_name, "menubox%d",  menu_counter);
		menubox[menu_counter] = XtCreateManagedWidget(
			widget_name, 			/* widget name   */
			boxWidgetClass, 		/* widget class */
			cdshell[menu_counter], 	/* parent widget*/
			NULL, 					/* argument list*/
			0 						/* arglist size */
			);

		sprintf(widget_name, "menulabel%d",  menu_counter);
		menulabel[menu_counter] = XtCreateManagedWidget(
			widget_name, 			/* widget name   */
			labelWidgetClass,		/* widget class */
			menubox[menu_counter],	/* parent widget*/
			NULL,					/* argument list*/
			0 						/* arglist size */
			);
		if(menu_counter < CD_MENUS - 1) {
			sprintf(widget_name, "nextmenu%d",  menu_counter);
			nextmenu[menu_counter] = XtCreateManagedWidget(
				widget_name, 			/* widget name   */
				commandWidgetClass,		/* widget class */
				menubox[menu_counter],	/* parent widget*/
				NULL,					/* argument list*/
				0 						/* arglist size */
				);
		}
		XtAppAddActions(app_context, trial_actions, XtNumber(trial_actions));

		for (itrack = 0;itrack < CD_TRACKS && track_counter <tracks;
					++itrack, ++track_counter) {
			sprintf(buf, "menupane%d", track_counter);
			menupane[track_counter] = 
					XtCreateManagedWidget(buf,   /* widget name */
						commandWidgetClass, menubox[menu_counter], NULL, 0);

			XtAddCallback(menupane[track_counter], XtNcallback, 
					TrackMenuSelect, &TrackNumbers[track_counter]);
		}
	}
	XtAppAddActions(app_context, trial_actions, XtNumber(trial_actions));

	XtAddCallback(cdshell[0], XtNpopupCallback, PlaceMenu, 0);
}

