/***************************************************************************
 *	messenger.c: ѤΥåܥå
 *		
 *			Date. 1998/07/13 -- 1998/07/29
 *				Programed by Nobuyuki Maruichi
 *
 *	Note.
 *			JIS X0208-1983/1990
 *			Tab Size 4 / Shift Width = 4
 ***************************************************************************/

/***********************************************
 *	øɸ饤֥Υ󥯥롼ɥե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
/*************************************
 *	X Toolkit Υ󥯥롼ɥե
 *************************************/
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
/*****************************************
 *	Athena Widget Υ󥯥롼ɥե
 *****************************************/
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Label.h>
#include <X11/Shell.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
/********************************
 * ѤΥ󥯥롼ɡե
 ********************************/
#include "stringuty.h"

/***************************************************************************
 *	messengerSelected: åɥ륳Хåؿ
 *	
 *		void messengerSelected(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				ХåƤӽФå
 *		XtPointer client_data;	åɥ˴ؤ
 *		XtPointer call_data;	̤
 *	֤
 *		ʤ
 *	
 *		åɥνԤ
 *		ŪˤϡʲΤ褦ʽԤ
 *		1. client_data Ϥ줿Ÿ롣
 *		2.ХθСʥǥХåΤȤΤߡ
 *		3. client_data Ϥ줿󤫤򤵤줿ܥֹ
 *		롣
 *		4.ХåؿƤӽФ
 *		5.åݥåץåפܥͭˤ
 *		6.åݥåץåץݥåץ󤷤˴
 *		
 ***************************************************************************/
void messengerSelected(Widget w, XtPointer client_data, XtPointer call_data)
{
	int result;
	int argcount;
	int argWidgetTop;
	int buttons;
	int currentCount;
	PointorsLink *linkBuffer;
	PointorsLink *currentLink = (PointorsLink*)client_data;
	Widget messengerPopup;
	Widget popupButton;
	XtCallbackProc callbackProc;

	linkBuffer = (PointorsLink*)terminalSearch(currentLink, prevPointersLink);
	currentCount = terminalCount(currentLink, prevPointersLink);
	argcount = VaGetValuesLink(linkBuffer, 
							XtRInt,	&result, sizeof(result),
							XtRInt,	&argWidgetTop, sizeof(argWidgetTop),
							XtRInt,	&buttons, sizeof(buttons),
							XtRWidget, &messengerPopup, 0,
							XtRWidget, &popupButton, 0,
							XtRCallback, &callbackProc, 0, 
							NULL);
#ifdef	DEBUG
	if(argcount != 6) {
		printf("%s:%d: նᡢ⤷ϡʬ˴ط"
				"ǥ󥰤꤬ޤ\n", __FILE__, __LINE__);
	}
#endif	/*DEBUG*/
	*((int*)linkBuffer->data_ptr) = result = currentCount - argWidgetTop;
	if(callbackProc != NULL)
		callbackProc((Widget)currentLink->data_ptr, linkBuffer, (XtPointer)result);
	if(popupButton != NULL) {
		/*****************************************************
		 *	åݥåץåפܥͭˤ
		 *****************************************************/
		XtSetSensitive(popupButton, True);
	}
	if(messengerPopup != NULL) {
		/*****************************************************
		 *	åݥåץåפݥåץ󤷤˴
		 *****************************************************/
		XtPopdown(messengerPopup);
		XtDestroyWidget(messengerPopup);
	}
	VaDestroyPointorsLink(linkBuffer);
}

/***************************************************************************
 *	SetPopupPosition: ƥåȤ˥ݥåץåװ֤
 *	
 *		void SetPopupPosition(Widget popupShell);
 *	
 *		Widget popupShell;	ݥåץåץ
 *	֤
 *		ʤ
 *	
 *		ݥåץåץοƥåȤ˥ݥåץåװ֤
 *		
 ***************************************************************************/
void SetPopupPosition(Widget popupShell)
{
	Position x, y;
	/* Dimension width, height; */
	
	/***********************************
	 *	Root Window κɸϤѴ
	 ***********************************/
	XtTranslateCoords(XtParent(popupShell),		/* Widget */
						(Position) 0,			/* x */
						(Position) 0,			/* y */
						&x, &y);				/* coords on root window */

	/*******************************************************************
	 *	ݥåץåץΰ֤ꤹʤޤвƤʤ
	 *******************************************************************/
	XtVaSetValues(popupShell, XtNx, x, XtNy, y, NULL);
}

/***************************************************************************
 *	messengerPrintf: åɽѤΥݥåץåץɥ
 *	
 *		PointorsLink *messengerPrintf(Widget parent, Widget popupButton, 
 *			XtCallbackProc callbackProc, XtPointer client_data, 
 *			const char **buttonMessages, const char *formattedString, ...);
 *	
 *		Widget parent;					ƥå
 *		Widget popupButton;				
 *		XtCallbackProc callbackProc;	ݥåץΤȤ˸ƤӽФ
 *										Хåؿ
 *		XtPointer client_data;			̤
 *		const char **buttonMessages;	ƥܥΥåؤΥݥ
 *		const char *formattedString;	printf() Υեޥåʸ
 *		...								Ѱʬ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
PointorsLink *messengerPrintf(Widget parent, Widget popupButton, 
				XtCallbackProc callbackProc, XtPointer client_data, 
				const char **buttonMessages, const char *formattedString, ...)
{
	int argcount;
	int argWidgetTop;
	int result = 0;
	int buttons;
	int counter;
	PointorsLink *linkBuffer, *wLink_ptr;
	char messButtonName[40];
	char buffer[4096];
	Widget fromHoizWidget;
	Widget *messengerButtons;
	Widget messengerPopup, messengerForm, messengerLabel;
	va_list argument;

	va_start(argument, formattedString);		/* ѰΤ */

	vsprintf(buffer, formattedString, argument);

	buttons = arrayCount((XtPointer*)buttonMessages);
	if(buttons > 256) {
		fprintf(stderr, "%s:%d:multiMessagePrintf():"
				"To many buttons!! [%d]\n", __FILE__, __LINE__, buttons);
		exit(1);
	}
	messengerButtons = (Widget*)XtMalloc(sizeof(*messengerButtons) * buttons);
	messengerPopup = XtVaCreatePopupShell(
				"messengerPopup",
				transientShellWidgetClass,
				parent,
				NULL);

	messengerForm = XtVaCreateManagedWidget(
				"messengerForm",
				formWidgetClass,
				messengerPopup,
				NULL);

	messengerLabel = XtVaCreateManagedWidget(
				"messengerLabel",
				labelWidgetClass,
				messengerForm,
				XtNlabel, buffer,
				NULL);

	argcount = VaCreateValuesLink(&linkBuffer, 
							XtRInt,	&result, sizeof(result),
							XtRInt,	&argWidgetTop, sizeof(argWidgetTop),
							XtRInt,	&buttons, sizeof(buttons),
							XtRWidget, messengerPopup, 0,
							XtRWidget, popupButton, 0,
							XtRCallback, callbackProc, 0, 
							NULL);
	*((int*)linkBuffer->nextLink->data_ptr) = argWidgetTop = argcount;

	for(counter = 0, fromHoizWidget = NULL;counter < buttons;
				fromHoizWidget = *(messengerButtons+counter), ++counter) {
		sprintf(messButtonName, "messengerButton%d", counter);
		*(messengerButtons+counter) = 
				XtVaCreateManagedWidget(
						messButtonName,
						commandWidgetClass,
						messengerForm,
						XtNfromVert, messengerLabel, 
						XtNlabel, *(buttonMessages + counter),
						NULL);
		if(fromHoizWidget != NULL) {
			/* дΥå */
			XtVaSetValues(*(messengerButtons+counter), 
						XtNfromHoriz, fromHoizWidget, NULL);
		}
		argcount += VaAddValuesLink(&linkBuffer, 
								XtRWidget, *(messengerButtons+counter), 0, NULL);
	}
	wLink_ptr = (PointorsLink*)numSearch(linkBuffer, argWidgetTop, nextPointersLink);
	for(counter = 0;counter < buttons && wLink_ptr != NULL;
							++counter, wLink_ptr = wLink_ptr->nextLink) {
		XtAddCallback(*(messengerButtons+counter), XtNcallback, messengerSelected, wLink_ptr);
	}
	SetPopupPosition(messengerPopup);	/* ݥåץåװ֤η */
	XtRealizeWidget(messengerPopup);	/* ݥåץåץμ¸ */
	XtPopup(messengerPopup, XtGrabExclusive);
	
	va_end(argument);					/* Ѱ˴ؤ */
	
	return(linkBuffer);
}
