/****************************************************************************
 *	Operation.c: 㡼ȤɽΥå
 *
 *			Date. 1997/11/02 --
 *				Programed by Nobuyuki Maruichi
 *
 *	Note.
 *			Tab Size 4 / Shift Width = 4
 *	from
 *		StripChart.c(Athena Widget)
 *		mwxcd.c(mwxcd) Copyright (C) 1994-1997 N.Maruichi
 ***************************************************************************/

#define DEBUG

/***************************************************************************

	̾
		Operation åȡݡ㡼ȤɽΥå
	
		ѥ֥åإå:	<X11/StringDefs.h> "Operation.h"
		ץ饤١ȥإå:	"OperationP.h"
		饹̾:			Operation
		饹ݥ:		operationObjectClass
		󥹥󥹲:		widget = XtCreateWidget(name, 
												operationObjectClass, ...)
	饹
		ObjectOperation
	
		Operation åȤϡCD Τ˻Ѥޤ
	꥽
		Operation åȤΥ󥹥󥹤ȤΥ꥽
		ꥹȤ꥽ǡ١鸡ޤ

̾(XtN...)饹      ǥեȡ⡡

XtNdestroyCallbackXtCallbackList  NULL          XtDestroyWidget() 
  Ф륳Хè
  

XtNcallback XtCallbackList  NULL          CDץ졼εưѨ
  Ф륳Ш
  å

XtNplayingMode  int -1            ʽˤΨ
  Ƭν֡

XtNprogramCount int -1            ʽˤΨ
  Ƭν֡

XtNprogramSelectedint -1            Υץਭ
  Ƭν֡
                


	Operation åȤο꥽ʥѡ饹ѾΤǤ
	ʤˤϡʲΤȤǤ
	
	XtNhighlight
		åȤΥ顼ޥåפФ륤ǥåȤƤΥԥ͡
		򥰥վΥ饤ο˻Ȥޤ
	XtNminScale
		դκǾäΤ롣
	XtNtopLimit
		վüΣٺɸ򥰥դΥɽʪ
	XtNbottomLimit
		ղüΣٺɸ򥰥դΥɽʪ
	XtNleftLimit
		պüΣغɸ򥰥դΥɽʪ
	XtNrightLimit
		ձüΣغɸ򥰥դΥɽʪ

#define programTagend(playing)	LinkLast(&playing->program, Cd_Order_Next)
#define programCurrent(playing)	(&playing->selected)
#define playingMode(playing)	(&playing->mode)
#define playingChange(playing)	PlayingChange(playing)
#define playingNormal(playing)	(&playing->normal)
#define playingProgram(playing)	(&playing->program)
#define playingCurrent(playing)	(&playing->current)

 **************************************************************************/

/***********************************************************************
 *
 * Operation Widget
 *
 ***********************************************************************/

#include <stdio.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
B
#include <X11/Xfuncs.h>
#include <X11/Xatom.h>
#include <X11/Xmu/Atoms.h>
#include "OperationP.h"

/* Private Data */

#define offset(field) XtOffsetOf(OperationRec, field)

static XtResource resources[] =
{
	{XtNcallback, XtCCallback, XtRCallback, sizeof(XtPointer),
		 offset(operation.callbacks), XtRCallback, (XtPointer)NULL},
	{XtNplayingMode, XtCPlayingMode, XtRBoolean, sizeof(Boolean),
		 offset(operation.callbacks), XtRImmediate, (XtPointer)NormalOrder},
	{XtNprogramCount, XtCProgramCount, XtRInt, sizeof(int),
		 offset(operation.programPoint), XtRImmediate, (XtPointer)NormalOrder},
	{XtNprogramSelected, XtCProgramCount, XtRInt, sizeof(int),
		 offset(operation.programPoint), XtRImmediate, (XtPointer)NormalOrder},
};

#undef offset

static void Initialize(), Destroy(), Redisplay(), MoveOperation();
static Boolean SetValues();
static void Realize(Widget w, 
					Mask *valueMask, XSetWindowAttributes *attributes);
static void Resize(Widget w);

OperationClassRec operationClassRec = {
	{	/* object fields */
		/* superclass				*/ (WidgetClass) & objectClassRec,
		/* class_name				*/ "Operation",
		/* size						*/ sizeof(OperationRec),
		/* class_initialize			*/ XawInitializeWidgetSet,
		/* class_part_initialize	*/ NULL,
		/* class_inited				*/ FALSE,
		/* initialize				*/ Initialize,
		/* initialize_hook			*/ NULL,
		/* obj1 [padding]			*/ NULL,
		/* obj2 [padding]			*/ NULL,
		/* obj3 [padding]			*/ 0,
		/* resources				*/ resources,
		/* num_resources			*/ XtNumber(resources),
		/* xrm_class				*/ NULLQUARK,
		/* obj4 [padding]			*/ FALSE,
		/* obj5 [padding]			*/ 0,
		/* obj6 [padding]			*/ FALSE,
		/* obj7 [padding]			*/ FALSE,
		/* destroy					*/ Destroy,
		/* obj8 [padding]			*/ NULL,
		/* obj9 [padding]			*/ NULL,
		/* set_values				*/ SetValues,
		/* set_values_hook			*/ NULL,
		/* obj10[padding]			*/ NULL,
		/* get_values_hook			*/ NULL,
		/* obj11[padding]			*/ NULL,
		/* version					*/ XtVersion,
		/* callback_private			*/ NULL,
		/* obj12[padding]			*/ NULL,
		/* obj13[padding]			*/ NULL,
		/* obj14[padding]			*/ NULL,
		/* extension				*/ NULL
	},
	{	/* Simple class fields */
		/* change_sensitive			*/ XtInheritChangeSensitive
	}
};

WidgetClass operationObjectClass = (WidgetClass)&operationClassRec;

/****************************************************************
 *
 * Private Procedures
 *
 ****************************************************************/

/***************************************************************************
 *	Initialize: ilitialize ᥽åɡʥåȤνԤ
 *	
 *		static void Initialize(Widget greq, Widget gnew, 
 *								ArgList args, Cardinal *num_args);
 *	
 *		Widget greq;		꥽ͤꥹȡ꥽ǡ١
 *							åȤΥǥեͤꤹ륦å
 *							䥪֥ȤΥ󥹥󥹤ꤷޤ
 *		Widget gnew;		ѡ饹 initialize() ᥽åɤˤä
 *							ѹˤäѹ꥽꥽Ǥʤ
 *							ͤȶˡƱåȤ䥪֥Ȥ
 *							ޤ
 *		ArgList args;		XtCreateWidget() ϤꥹȤꤷޤ
 *							̤ѡ
 *		Cardinal *num_args;	ꥹȤǿꤷޤ
 *							̤ѡ
 *	
 *		դιֳ֤ˤäơॢȴؿϿ
 *		եåƥȤ
 *		դΥǾΥꤹ롣
 *		ǡݥȡintervalˤν
 *		͡max_valueˤν
 *		դΥ饤褹뤿ν򤪤ʤ
 ***************************************************************************/
/* ARGSUSED */
static void Initialize(Widget greq, Widget gnew, 
						ArgList args, Cardinal *num_args)
{
	OperationObject w = (OperationObject) gnew;
}

/***************************************************************************
 *	Destroy: Operation åȤ Destroy ᥽å
 *	
 *		static void Destroy(Widget w);
 *	
 *		Widget w;
 *	
 *		ॢȴؿϿ롣
 *		դΥ饤κɸǡ
 *		եåƥȤ롣
 ***************************************************************************/
static void Destroy(Widget gw)
{
	OperationObject w = (OperationObject) gw;

}

/***************************************************************************
 *	SetValues: Operation åȤ set_values ᥽å
 *	
 *		static Boolean SetValues(Widget current, Widget request, 
 *					Widget new, ArgList args, Cardinal *num_args);
 *	
 *		Widget current;		XtSetValues() ƤӽФξ֤ΥåȤ
 *							ԡ
 *		Widget request;		XtSetValues() ƤӽФͤѹ줿
 *							Υ饹 set_values() ؿƤӽФƤ
 *							֤ΥåȤΥԡ
 *		Widget new;			ǤꤵƤ set_values() ƤӽФǽ
 *							줿å
 *		ArgList args;		XtSetValues() ƤӽФϤ줿ꥹ
 *							̤ѡ
 *		Cardinal *num_args;	ꥹΰο̤ѡ
 *	֤
 *		Falseʵ: 	åȤ褹
 *		True ʿ: 	åȤ褷ʤ
 *	
 *		ʲΥ꥽ˤĤơɬפ뤫Ƚꤹ롣
 *		
 *		minScale ꥽		ǾѹѹȽꤹ
 *		foreground ꥽	ʿ
 *		highlight ꥽	饤迧
 *	Ȼ
 *		See. X Toolkit Intrinsics Reference Manual		XtSetValuesFunc
 *														set_values ᥽å
 *			 X Toolkit Intrinsics Programing Manual		set_values ᥽å
 ***************************************************************************/
/* ARGSUSED */
static Boolean SetValues(Widget current, Widget request, 
							Widget new, ArgList args, Cardinal *num_args)
{
	OperationObject old = (OperationObject) current;
	OperationObject w = (OperationObject) new;
	Boolean ret_val = FALSE;

	if (w->operation.fgpixel != old->operation.fgpixel) {
		new_gc |= FOREGROUND;
		ret_val = True;
	}
	if (w->operation.hipixel != old->operation.hipixel) {
		new_gc |= HIGHLIGHT;
		ret_val = True;
	}

	return (ret_val);
}

/***************************************************************************
 *	GetValuesHook: ꥽ꥹȤ̵꥽᥽å
 *	
 *		static void GetValuesHook(Widget w,ArgList args,Cardinal *num_args);
 *	
 *		Widget w;			Textåȡʸ륦åȡ
 *		ArgList args;		XtGetValues() ϤꥹȤ
 *		Cardinal *num_args;	ꥹǤο
 *	֤
 *		ʤ
 *	
 *		꥽ꥹȤ̵꥽Object饹᥽å
 *		X Toolkit Intrinsics Reference Manual   XtArgsProc
 *											  get_values_hook ᥽å
 *		X Toolkit Intrinsics Reference Manual ˤϡδؿ˴Ϣ Text
 *		åȤ GetValuesHook ⤬ޤ
 *		TextåȤ GetValuesHook ؿ MultiSourceåȤ
 *		MultiSinkʤɤΥ꥽ԤޤܸǤǤϡP.489 Ǥ
 *		
 ***************************************************************************/
static void GetValuesHook(Widget w, ArgList args, Cardinal *num_args)
{
	OperationObject op = (OperationObject) w;
	int counter

	for(counter = 0; counter < *num_args; counter++) {
		if(streq(args[counter].name, XtNprogramCount)) {
			/*****************************************
			 *	XtNprogramCount ꥽μξ
			 *****************************************/
			*((int*)args[counter].value) = 
							ProgramCount(op->operation.current);
		}
		if(streq(args[counter].name, XtNprogramSelected)) {
			/********************************************
			 *	XtNprogramSelected ꥽μξ
			 ********************************************/
			*((int*)args[counter].value) = 
							ProgramCount(op->operation.selected);
		}
	}
}

/***************************************************************************
 *	RedrawGraph: ԥޥåפȷΥ褹
 *	
 *		static void RedrawGraph(OperationObject oP);
 *	
 *		OperationObject oP;		the wave operation widget
 *	֤
 *		ʤ
 *	
 *		ѤΥХåƤӽФ
 *
 ***************************************************************************/
static void RedrawGraph(OperationObject oP)
{
	XtCallCallbackList((Widget)oP, 
					oP->operation.callbacks, (XtPointer)&repaintInfo);
}

/***************************************************************************
 *	RedrawGraph: ԥޥåפȷΥ褹ʥѥ֥åؿ
 *	
 *		static void RedrawGraph(OperationObject oP);
 *	
 *		OperationObject oP;		the wave operation widget
 *	֤
 *		ʤ
 *	
 *		ѤΥХåƤӽФ
 *
 ***************************************************************************/
void XawOperationRedrawCall(Widget w)
{
	OperationObject oP = (OperationObject)w;

	RedrawGraph(oP);
}

/***************************************************************************
 *	PlayingChange: ե⡼ɤؤ
 *	
 *		void PlayingChange(MultiPlay *playing);
 *	
 *		MultiPlay *playing;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void XmwOperationChange(Widget w)
{
	OperationObject oP = (OperationObject)w;
	
	if(operation->mode == NormalOrder) {
		operation->mode = ProgramOrder;
		operation->current = operation->selected;
	} else {
		operation->mode = NormalOrder;
		operation->current = operation->normal;
	}
}
#endif	/*EXPRIMENT*/

int ProgramCount(Cd_Order *traceOrder)

