/***************************************************************************
 *	townscdda.h: Towns  CD-DA ֘AɊւ\̒`
 *
 *	
 *	
 ***************************************************************************/

#ifndef _TOWNS_CDIOC_SUBSET_H
#define _TOWNS_CDIOC_SUBSET_H

struct cd_time {
  u_char minute, second, frame;
};

struct cdda_play {
  struct cd_time start;
  struct cd_time end;
  int count;
};

struct cd_toc {
  int type;
  int s_track, e_track;
  struct cd_time total;
  struct cd_time track[100];
};

struct cd_toc2 {
  int type;
  int s_track, e_track;
  struct cd_time total;
  struct cd_time track[100];
  u_char mode[100];
};

struct cd_subq {
  int playing; /* specify channel# */
  u_char ctladr;
  u_char track;
  u_char index;
  struct cd_time offset; /* from begining of the track */
  u_char reserv3;
  struct cd_time time; /* absolute */
};

#define CDIOCDOOR		0x4301		/* door control */
# define CDIOCDOOR_OPEN		 0x02
# define CDIOCDOOR_CLOSE	 0x04

#endif /* _TOWNS_CDIOC_SUBSET_H */
