/***************************************************************************
 *	word_gui.c - λϢεǽ
 *	
 *			1995/ 4/30 (sun.) -- 
 *
 *					Programmed by Nobuyuki Maruichi
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208-1990
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>

/***********************************************
 *	X Toolkit δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

/**************************************************************
 * Atena Widgetݲ Atena Widget Υ󥯥롼ɡե
 **************************************************************/
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/TextSrc.h>
#include <X11/Xaw/TextSink.h>
#include <X11/Xaw/MultiSrc.h>
#include <X11/Xaw/MultiSink.h>
#ifdef	X11R5
# include <X11/Xaw/XawIm.h>
# include <X11/Xaw/Xawi18n.h>
#endif	/*X11R5*/

/**************************************
 * mwxcd ѤΥ󥯥롼ɡե
 **************************************/
#include "mwxcd.h"
#include "cdda_ext.h"
#include "cd_data.h"
#include "cd_word.h"
#include "file_sel.h"
#include "stringuty.h"
#include "luty.h"

/*****************************************
 *	Хѿ
 *
 *
 *****************************************/
Widget pEnterShell;
Widget wordsShell, wordsBlocks;
Widget wordsFileBlock, wordsPopdown, wordsEditable;
Widget wordsSave, wordsLoad, wordsFilename;
Widget wordsEditBlock, wordsSetTiming, wordsInsTiming, wordsDelTiming;
Widget wordsInsSpace, wordsDecSec, wordsIncSec;
Widget wordsEdit, wordsFlashing;
Widget wordsSyncronize, wordsJump, wordsUnselect;
Widget wordsTrackBlock, wordsTitle, wordsSetMax, wordsAllowResize; 
Widget wordsDecTrack, wordsIncTrack;
Widget wordsView, wordsList, wordsTextShell, wordsTextBlocks;
Widget wordsTFileBlock, wordsTPopdown, wordsTFilename;
Widget wordsTEdit;
Widget verifyShell, verifyMessage;
extern Widget cmenupane[10];
char DiscDataFilename[256];
static Boolean popupShellFlag = False;
static const char *WordsDataError = NULL;

static struct cd_time wordsJumpTime = {EOF,EOF,EOF};
static int wordsIndex;
DiscWord *CurrentWords_ptr = NULL;
int CurrentWordsTrack;
int wordFileEncode = EOF;
int wrdTextFileEncode = EOF;
char **currentWordList = NULL;
char **printableWordList = NULL;
static char **wordsListArray = (char **)&wordsListArray;
/*String printableWordArray[200];*/
extern AppData app_data;
XawPannerReport wordsGeometry = { 0, 0, 0, 1, 1, 1, 1};
static PopdownInfo wordsTShellPopdown;
static PopdownInfo verifyShellPopdown;
static int wordsHeight = 0;

static void (*verifyYesFunc)(Widget w, XtPointer client_data, XtPointer call_data) = NULL;
static void (*verifyNoFunc)(Widget w, XtPointer client_data, XtPointer call_data) = NULL;

/***************************************************************************
 *	ãģ̥եϢΥХѿ
 *		CurrentDisc_ptr:	ߤΥǥΣãģ̥ǡؤݥ
 *		CurrentDiscFlag:	ߤΥǥãģ̥ǡȤƥ󥯺Ѥ
 *			 TRUE :	󥯺ѡʣãģ̥ե˵ϿѤϿѡ
 *			 FALSE:	󥯤Ƥʤʿãġ
 ***************************************************************************/
extern CddaDataForm *CurrentDisc_ptr;
extern int CurrentDiscFlag;	
extern Pixmap trackDecPixmap, trackIncPixmap, vup_pixmap, vdown_pixmap;
extern Pixmap vupDisablePixmap, vdwDisablePixmap;
extern Pixmap eject_pixmap, ejectDisable_pixmap;
extern Pixmap diskMark;

void makeTrackWords(int track);
void WordsSelect(Widget w, XtPointer client_data, XtPointer call_data);
void WordsSyncronizeGeometry(int index);
void WordsScroll(int y);
void WordsEditable(Widget w, XtPointer client_data, XtPointer call_data);

/***************************************************************************
 *	WordsListPopup: ץࡦꥹȤΥݥåץå׺ɸȤ
 *	
 *		void WordsListPopup(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;		topLevel ˥㥹Ȥ
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void WordsListPopup(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget topLevel = (Widget) client_data;
	Position x, y;
	Dimension width, height;

	/*
	 *	topLevel widget 礭롣
	 */
	XtVaGetValues(topLevel, 
			XtNwidth, &width,
			XtNheight, &height,
			NULL);
	
	/*
	 *	topLevel widget Υ롼ȡɥΰ֤
	 */
	XtTranslateCoords(topLevel, 	/* Widget */
			(Position) width/2, 	/* x */
			(Position) height/2,	/* y */
			&x, &y); 				/* coords on root window */

	/*
	 *	ץࡦꥹȡݥåץåפΰ֤ꤹ롣
	 *	ʤޤԲĻξ֡
	 */
	XtVaSetValues(wordsShell, 
			XtNx, x,
			XtNy, y,
			NULL);
	
	popupShellFlag = True;
}

/***************************************************************************
 *	anyWindowPopup: ݥåסåסɥΰַԤ
 *	
 *		void anyWindowPopup(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				ݥåסåפ׵ᤷå
 *		XtPointer client_data;	ݥåץåפ륷롦å
 *		XtPointer call_data;	̤
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void anyWindowPopup(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget parent_w;
	Widget popupShell = (Widget) client_data;
	Position x = 0, y = 0;
	Dimension width, height;

	/*******************************************************************
	 *	顼åݥåסåסɥΰ֤
	 *		ƥåȤ礭̴˺ɸѴ
	 *		ʤΤȤݥåץåפԲĻ
	 *******************************************************************/
	parent_w = XtParent(w);
	if(parent_w != NULL) {
		XtVaGetValues(parent_w, XtNwidth, &width, XtNheight, &height, NULL);
		XtTranslateCoords(parent_w, 	/* Widget */
				(Position) width/4, 	/* x */
				(Position) height/2,	/* y */
				&x, &y); 				/* coords on root window */
	}
	/*
	 *	ץࡦꥹȡݥåץåפΰ֤ꤹ롣
	 *	ʤޤԲĻξ֡
	 */
	XtVaSetValues(popupShell, XtNx, x, XtNy, y,NULL);	/*  */
}

#define is_crlf(string)	((*(string)) == '\r' && *((string)+1) == '\n')

/***************************************************************************
 *	isWordsFile: ףңĥե뤫ɤñʥƥȤԤ
 *	
 *		int isWordsFile(const char *filename);
 *	
 *		const char *filename;	ե̾
 *	֤
 *		ţϣơ	ףңĥեǤϤʤ
 *				ףңĥեǤʲǽ⤤
 *		ʾ塧	顼ȽǤʤե뤬¸ߤʤʤɡ
 *	
 *		եƬΣԤ顢ʰפΣףңĥեƥȤԤ
 *		ƥȹܤϡʲ
 *		ǽιԤ%05d\r\nɤηǤ뤫
 *		ιԤ##\r\nɤǤ뤫
 ***************************************************************************/
int isWordsFile(const char *filename)
{
	int status = 0;
	int counter;
	char buffer[256], *receive_ptr = NULL;
	FILE *stream;
	
	stream = fopen(filename, "rb");
	if(stream != NULL) {
		receive_ptr = fgets(buffer, sizeof(buffer), stream);
		if(receive_ptr != NULL) {
			counter = 0;
			while(*(buffer+counter) != '\r' && isspace(*(buffer+counter)))
				++counter;
			while(*(buffer+counter) != '\r' && isdigit(*(buffer+counter)))
				++counter;
			status |= !is_crlf(buffer+counter);
			receive_ptr = fgets(buffer, sizeof(buffer), stream);
			if(receive_ptr != NULL) {
				status |= (buffer[0] != '#');
				status |= (strcmp(buffer + 3, "#\r\n") != 0);
			}
		}
		fclose(stream);
		if(receive_ptr != NULL) {
			status = ((status != 0)?(EOF):(0));
		}
	}
	if(receive_ptr == NULL) {
		status = errno;
	}
	return(status);
}

/***************************************************************************
 *	WordsLoad: λǡ(WRD)եɤ߹
 *	
 *		void WordsLoad(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ץࡦꥹȤɤ߹ߡ顼ʳʤ顢ץࡦꥹȡ
 *		ɥ򹹿롣
 ***************************************************************************/
/*ARGSUSED*/
void WordsLoad(Widget w, XtPointer client_data, XtPointer call_data)
{
	int status;
	String filename;
	FILE *fp;
	char errorReport[80];
	
	XtVaGetValues(wordsFilename, XtNstring, &filename, NULL);
	status = isWordsFile(filename);
	if(status == 0) {
		if((fp = fopen(filename, "rb")) != NULL) {
			DiscWordRelease(CurrentWords_ptr);
			CurrentWords_ptr = NULL;
			CurrentWords_ptr = DiscWordAlloc(CurrentDisc_ptr->tracks);
			getWord(CurrentWords_ptr, fp);
			fclose(fp);
		}
		CurrentWordsTrack = 1;
		makeTrackWords(CurrentWordsTrack);
	}
	switch(status) {
	default:
		WordsDataError = filename;
		if(WordsDataError == NULL) {
			sprintf(errorReport, "%s(%d)", __FILE__, __LINE__);
			WordsDataError = errorReport;
		}
		PopupSyserrMessage(WordsDataError);
		break;
	case EOF:		/* ꤵ줿ե뤬ףңĥեηǤʤ */
		WordsDataError = keyword2mes("WrdIllegalFormat");
		if(WordsDataError == NULL) {
			sprintf(errorReport, "%s(%d)", __FILE__, __LINE__);
			WordsDataError = errorReport;
		}
		PopupMessage(WordsDataError);
		break;
	case 0:			/* Normal End */
		break;
	}
}

/***************************************************************************
 *	moveWordsBackup: ꤵ줿եХååץեˤ
 *	
 *		static int moveWordsBackup(const char *filename);
 *	
 *		const char *filename;	
 *	֤
 *					顼ʤ
 *		ʳ		顼ֹ
 *	
 *		ꤵ줿ե͡षƥХååץեˤ롣
 ***************************************************************************/
static int moveWordsBackup(const char *filename)
{
	int result = 0, status;
	String backupName;
	
	backupName = backupNameAlloc(filename);
	
	if(backupName != NULL) {
		result = status = isWordsFile(backupName);
		switch(status) {
		default:
			WordsDataError = keyword2mes("WrdBackupError");
			break;
		case EOF:		/* Хååץե뤬ףңĥեηǤʤ */
			WordsDataError = keyword2mes("WrdBackupIllegal");
			result = 0;
			break;
		case 0:			/* Normal End */
			break;
		case ENOENT:	/*	Хååסե뤬¸ߤʤ */
			result = status = 0;
			break;
		}
		if(result == 0) {
			result = isWordsFile(filename);
			switch(result) {
			default:
				WordsDataError = filename;
				break;
			case EOF:		/* ꤵ줿ե뤬ףңĥեηǤʤ */
				WordsDataError = keyword2mes("WrdIllegalFormat");
				break;
			case 0:			/* Normal End */
				result = status;
				if(result == 0) {
					if(rename(filename, backupName)) {
						result = errno;
					}
				}
				break;
			case ENOENT:	/*	ե뤬¸ߤʤ */
				result = 0;
				WordsDataError = NULL;
				break;
			}
		}
	} else {
		 WordsDataError = keyword2mes("WrdOutOfMemory");
		result = errno;
	}
#ifdef	DEBUG
	printf("backup filename = \"%s\"\n", 
				((backupName != NULL)?(backupName):("NULL Pointer")));
#endif	 /*DEBUG*/
	free(backupName);
	return(result);
}

/***************************************************************************
 *	discWordsTest: ʬβλ̷⤬ʤɤƥȤ
 *	
 *		int discWordsTest(DiscWord *lyrics);
 *	
 *		DiscWord *lyrics;		ǥβλ
 *	֤
 *		EOF		λʤ
 *			λ̷⤬ʤ
 *			λ̷⤬
 *	
 *		λ̷Ȥʤꤽ̵ɤĴ٤롣
 *		ȤʤꤽȸΤϡmwxcd  whips Ǥϡˤʤʤ
 *		Ƥ¾ whips  WRD եбƤ CD-PLAYER Ǥ⤷
 *		ˤʤ뤫ΤʤȤĴ٤ޤ
 *		
 ***************************************************************************/
int discWordsTest(DiscWord *lyrics)
{
	int counter;
	int flag = EOF, errorLine;
	char message[256];
	const char *trackTitle;
	TrackWord **trackWords_ptr_ptr;
	TrackWord *trackWords;
	extern struct cd_toc CddaToc;

	if(lyrics->trackWords != NULL) {
		trackWords_ptr_ptr = lyrics->trackWords;
		for(counter = 0, flag = 0;counter < lyrics->tracks && flag == 0;++counter) {
			/*
			 *	λ򥫥
			 */
			trackWords = *(trackWords_ptr_ptr+counter);
			errorLine = wordsTimeTest(trackWords, &CddaToc.track[counter],
								TrackEndTime(counter+CddaToc.s_track, &CddaToc));
			flag = (errorLine >= 1);
			if(flag) {
				--errorLine;
				if(errorLine >= 0) {
					TrackWord *currentWords;

					XtVaSetValues(wordsSyncronize, XtNstate, False, NULL);
					CurrentWordsTrack = counter+CddaToc.s_track;
					makeTrackWords(CurrentWordsTrack);
					WordsSyncronizeGeometry(errorLine);
					XawListHighlight(wordsList, errorLine);
					currentWords = wordCountSearch(trackWords, errorLine);
					if(errorLine < arrayCount((XtPointer)currentWordList) - 1) {
						WordsSelect(wordsList, NULL, XawListShowCurrent(wordsList));
					}
				}
				trackTitle = 
					cdljc((CurrentDisc_ptr->track_ptr + counter)->trackTitle);
				switch((int)LyricsError) {
				case WordsErrorNone:
					sprintf(message, "Track%d: %s %s", counter + 1, 
									trackTitle, keyword2mes("WrdError"));
					break;
				case WordsIllegalOrder:
					sprintf(message, "Track%d: %s %s", counter + 1, 
									trackTitle, keyword2mes("WrdIllegal"));
					break;
				case WordsTooLong:
					sprintf(message, "Track%d: %s %s", counter + 1, 
							trackTitle, keyword2mes("WrdStringTooLong"));
					break;
				}
				PopupMessage(message);
			}
		}
	}
	return(flag);
}

/***************************************************************************
 *	WordsSave: ףңĥե񤭹
 *	
 *		void WordsSave(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ʲεǽޤ
 *		ϿEnter˥⡼ɤ
 *		ףңĥե񤭹ࡣ
 ***************************************************************************/
/*ARGSUSED*/
void WordsSave(Widget w, XtPointer client_data, XtPointer call_data)
{
	int status = 0;
	String filename;
	char errorReport[80];
	FILE *fp;
	extern Widget eject;

	if(app_data.read_only == False) {
		WordsDataError = NULL;
		if(CurrentWords_ptr != NULL) {
			if(CurrentWords_ptr->trackWords != NULL) {
				if((status = discWordsTest(CurrentWords_ptr)) == 0) {
					XtVaGetValues(wordsFilename, XtNstring, &filename, NULL);
					if((status = moveWordsBackup(filename)) == 0) {
						if((fp = fopen(filename, "w")) != NULL) {
							putWord(CurrentWords_ptr, fp);
							fclose(fp);
						}
					}
				} else {
					if(status == 1)
						status = -2;
				}
			}
		}
		switch(status) {
		case -2:
			break;
		case 0:
			XtVaSetValues(wordsEditable, XtNstate, False, NULL);
			WordsEditable(wordsEditable, NULL, NULL);
			XtVaSetValues(eject, XtNbitmap, eject_pixmap, NULL);
			XtSetSensitive(eject, True);
			break;
		case EOF:
			if(WordsDataError == NULL) {
				sprintf(errorReport, "%s(%d)", __FILE__, __LINE__);
				WordsDataError = errorReport;
			}
			PopupMessage(WordsDataError);
			break;
		default:
			if(WordsDataError == NULL && filename != NULL) {
				WordsDataError = filename;
			}
			if(WordsDataError == NULL) {
				sprintf(errorReport, "%s(%d)", __FILE__, __LINE__);
				WordsDataError = errorReport;
			}
			PopupSyserrMessage(WordsDataError);
			break;
		}
	}
}

/***************************************************************************
 *	fWordsSelectFinish: ե롦쥯򤷤ե̾ꤹ
 *	
 *		void fWordsSelectFinish(const char *dirName, const char *fileName);
 *	
 *		const char *dirName;	ǥ쥯ȥ̾
 *		const char *fileName;	ե̾
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void fWordsSelectFinish(const char *dirName, const char *fileName)
{
	char filepath[4096];

	sprintf(filepath, "%s/%s", dirName, fileName);
#ifdef  XAW_BUG
	XtVaSetValues(wordsFilename, XtNstring, 
									XtNewString(filepath), NULL);
#else
	XtVaSetValues(wordsFilename, XtNstring, filepath, NULL);
#endif  /*XAW_BUG*/
}

/***************************************************************************
 *	wordsWindowSelector: ե롦쥯ƤӽФ
 *	
 *		void wordsWindowSelector(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void wordsWindowSelector(Widget w, XtPointer client_data, XtPointer call_data)
{
	char dirName[4096];
	char fileName[1024];
	String filepath;
	extern selectorPanes filePickupPaneInfo[];
	extern selectorPanes fileSortPaneInfo[];
	static selectorPanes *defPickup = &filePickupPaneInfo[2];
	static selectorPanes *defSort = &fileSortPaneInfo[1];

	XtVaGetValues(wordsFilename, XtNstring, &filepath, NULL);
	dirName[0] = '\0';
	fileName[0] = '\0';
	fileCheck(filepath, sizeof(dirName), dirName, sizeof(fileName), fileName);
	fileSelectorCall(w, dirName, defPickup, defSort, fWordsSelectFinish);
}

/***************************************************************************
 *	wordsTextSelectFinish: ե롦쥯򤷤ե̾ꤹ
 *	
 *		void wordsTextSelectFinish(const char *dirName, const char *fileName);
 *	
 *		const char *dirName;	ǥ쥯ȥ̾
 *		const char *fileName;	ե̾
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void wordsTextSelectFinish(const char *dirName, const char *fileName)
{
	char filepath[4096];

	sprintf(filepath, "%s/%s", dirName, fileName);
#ifdef  XAW_BUG
	XtVaSetValues(wordsTFilename, XtNstring, 
									XtNewString(filepath), NULL);
#else
	XtVaSetValues(wordsTFilename, XtNstring, filepath, NULL);
#endif  /*XAW_BUG*/
}

/***************************************************************************
 *	wordsTextSelector: ե롦쥯ƤӽФ
 *	
 *		void wordsTextSelector(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void wordsTextSelector(Widget w, XtPointer client_data, XtPointer call_data)
{
	char dirName[4096];
	char fileName[1024];
	String filepath;
	extern selectorPanes filePickupPaneInfo[];
	extern selectorPanes fileSortPaneInfo[];
	static selectorPanes *defPickup = &filePickupPaneInfo[0];
	static selectorPanes *defSort = &fileSortPaneInfo[1];

	XtVaGetValues(wordsTFilename, XtNstring, &filepath, NULL);
	dirName[0] = '\0';
	fileName[0] = '\0';
	fileCheck(filepath, sizeof(dirName), dirName, sizeof(fileName), fileName);
	fileSelectorCall(w, dirName, defPickup, defSort, wordsTextSelectFinish);
}

/***************************************************************************
 *	timingPlay: 
 *	
 *		void timingPlay(void);
 *	
 *		
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void timingPlay(void)
{
	int status;
	TrackWord *currentWords = NULL, *trackWords;
	extern int PlayingMode;
	struct cdda_play wordsEditPlay;
	extern struct cd_toc CddaToc;

	trackWords = *(CurrentWords_ptr->trackWords+CurrentWordsTrack-1);
	if(wordsIndex > 0) {
		currentWords = wordCountSearch(trackWords, wordsIndex);
		if(currentWords != NULL) {
			if(currentWords->wordTime.minute == 255)
				currentWords = NULL;
		}
	}
	if(currentWords != NULL) {
		wordsEditPlay.start = currentWords->wordTime;
	} else {
		wordsEditPlay.start = CddaToc.track[CurrentWordsTrack-1];
	}
	currentWords = wordCountSearch(trackWords, wordsIndex + 1);
	if(currentWords != NULL) {
		if(currentWords->wordTime.minute == 255)
			currentWords = NULL;
	}
	if(currentWords != NULL) {
		wordsEditPlay.end = currentWords->wordTime;
	} else {
		frame2time(time2frame(&CddaToc.track[CurrentWordsTrack+1])-1, 
													&wordsEditPlay.end);
	}
	status = cd_play2(&wordsEditPlay);		/*  */
	PlayingMode = PLAY;
}

/***************************************************************************
 *	WordsTimeSet: ꤵ줿λθߤαջ֤
 *	
 *		void WordsTimeSet(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsTimeSet(Widget w, XtPointer client_data, XtPointer call_data)
{
	int statuts = EOF;
	struct cd_subq subq;
	extern int PlayingMode;
	extern struct cd_subq CurrentSubq;
	TrackWord *currentWords, *trackWords = NULL;

	if(CurrentWords_ptr != NULL) {
		if(CurrentWords_ptr->trackWords != NULL) {
			trackWords = *(CurrentWords_ptr->trackWords+CurrentWordsTrack-1);
			if(CurrentWordsTrack <= CurrentWords_ptr->tracks) {
				if(PlayingMode == PLAY) {
					if(CurrentSubq.track == CurrentWordsTrack) {
						statuts = cd_status2(&subq);
					}
				}
			}
		}
	}
	if(statuts == 0) {
		currentWords = wordCountSearch(trackWords, wordsIndex);
		if(currentWords != NULL) {
			currentWords->wordTime = subq.time;
			currentWords->wordTime.frame = 0;
		}
		makeTrackWords(CurrentWordsTrack);
		if(wordsIndex < arrayCount((XtPointer)currentWordList) - 1) {
			++wordsIndex;
			XawListHighlight(wordsList, wordsIndex);
			WordsSelect(wordsList, NULL, XawListShowCurrent(wordsList));
			WordsSyncronizeGeometry(wordsIndex);
		}
	}
}

/***************************************************************************
 *	WordsDecSec: ꤵ줿λαջ֤Ĵ
 *	
 *		void WordsDecSec(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsDecSec(Widget w, XtPointer client_data, XtPointer call_data)
{
	int frames;
	int decFrames = 75;
	TrackWord *currentWords, *trackWords = NULL, frameWords;
	extern struct cd_toc CddaToc;
	Position xList, yList;

	XtVaGetValues(wordsList, XtNx, &xList, XtNy, &yList, NULL);
	if(CurrentWords_ptr != NULL) {
		if(CurrentWords_ptr->trackWords != NULL) {
			trackWords = *(CurrentWords_ptr->trackWords+CurrentWordsTrack-1);
			currentWords = wordCountSearch(trackWords, wordsIndex);
			if(currentWords != NULL) {
				if(currentWords->wordTime.minute == 255) {
					decFrames =0;
					frameWords.wordTime = 
								*TrackStartTime(CurrentWordsTrack, &CddaToc);
					frameWords.wordTime.frame = 0;
					++frameWords.wordTime.second;
					frames = time2frame(&frameWords.wordTime);
				} else {
					frames = time2frame(&currentWords->wordTime);
				}
				if(frames > time2frame(TrackStartTime(
								CurrentWordsTrack, &CddaToc)) + decFrames) {
					frames -= decFrames;
					frame2time(frames, &currentWords->wordTime);
					makeTrackWords(CurrentWordsTrack);
					XawViewportSetCoordinates(wordsView, xList, -yList);
					XawListHighlight(wordsList, wordsIndex);
					WordsSelect(wordsList, NULL, 
									XawListShowCurrent(wordsList));
				}
			}
		}
	}
}

/***************************************************************************
 *	WordsIncSec: ꤵ줿λαջ֤øĴ
 *	
 *		void WordsIncSec(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsIncSec(Widget w, XtPointer client_data, XtPointer call_data)
{
	int frames;
	int incFrames = 75;
	TrackWord *currentWords, *trackWords = NULL, frameWords;
	extern struct cd_toc CddaToc;
	Position xList, yList;

	XtVaGetValues(wordsList, XtNx, &xList, XtNy, &yList, NULL);
	if(CurrentWords_ptr != NULL) {
		if(CurrentWords_ptr->trackWords != NULL) {
			trackWords = *(CurrentWords_ptr->trackWords+CurrentWordsTrack-1);
			currentWords = wordCountSearch(trackWords, wordsIndex);
			if(currentWords != NULL) {
				if(currentWords->wordTime.minute == 255) {
					incFrames =0;
					frameWords.wordTime = *TrackEndTime(CurrentWordsTrack, &CddaToc);
					frameWords.wordTime.frame = 0;
					frames = time2frame(&frameWords.wordTime);
				} else {
					frames = time2frame(&currentWords->wordTime);
				}
				if(frames < time2frame(TrackEndTime(
									CurrentWordsTrack, &CddaToc)) - incFrames) {
					frames += incFrames;
					frame2time(frames, &currentWords->wordTime);
					makeTrackWords(CurrentWordsTrack);
					XawViewportSetCoordinates(wordsView, xList, -yList);
					XawListHighlight(wordsList, wordsIndex);
					WordsSelect(wordsList, NULL, 
									XawListShowCurrent(wordsList));
				}
			}
		}
	}
}

/***************************************************************************
 *	WordsInsSpace: ꤵ줿λľ˸ߤαջ֤ǶԤ
 *	
 *		void WordsInsSpace(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsInsSpace(Widget w, XtPointer client_data, XtPointer call_data)
{
	int flag = False;
	static struct cd_time wordsNoneTime = {EOF,EOF,EOF};
	TrackWord **currentWords_ptr_ptr, **trackWords_ptr_ptr = NULL;
	TrackWord *insWords = NULL;
	struct cd_subq subq;
	extern int PlayingMode;
	extern struct cd_subq CurrentSubq;

	if((CurrentWords_ptr != NULL)?
			(CurrentWords_ptr->trackWords != NULL):(0)) {
		trackWords_ptr_ptr = 
					(CurrentWords_ptr->trackWords+CurrentWordsTrack-1);
		if(CurrentWordsTrack <= CurrentWords_ptr->tracks) {
			currentWords_ptr_ptr = 
					wordsptrCountSearch(trackWords_ptr_ptr, wordsIndex);
			if(currentWords_ptr_ptr != NULL) {
				insWords = trackWordAlloc();
				if(insWords != NULL) {
					if(PlayingMode == PLAY) {
						if(CurrentSubq.track == CurrentWordsTrack) {
							if(cd_status2(&subq) == 0) {
								insWords->wordTime = subq.time;
								insWords->wordTime.frame = 0;
								flag = True;
							}
						} else {
							insWords->wordTime = wordsNoneTime;
						}
					} else {
						insWords->wordTime = wordsNoneTime;
					}
					insWords->word = (char*)malloc(1);
					if(insWords->word != NULL) {
						*insWords->word = '\0';
						insWords->next_ptr = *currentWords_ptr_ptr;
						*currentWords_ptr_ptr = insWords;
						makeTrackWords(CurrentWordsTrack);
					} else {
						wordRelease(insWords);
					}
				}
			}
		}
	}
	if(wordsIndex < arrayCount((XtPointer)currentWordList) - 1
											 && flag == True) {
		++wordsIndex;
		XawListHighlight(wordsList, wordsIndex);
		WordsSelect(wordsList, NULL, XawListShowCurrent(wordsList));
		WordsSyncronizeGeometry(wordsIndex);
	}
}

/***************************************************************************
 *	WordsTimeIns: Ԥ˸ߤαջ֤ơʳιԤ򤺤餹
 *	
 *		void WordsTimeIns(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsTimeIns(Widget w, XtPointer client_data, XtPointer call_data)
{
	static struct cd_time wordsNoneTime = {EOF,EOF,EOF};
	String insWordsString;
	TrackWord **currentWords_ptr_ptr, **trackWords_ptr_ptr = NULL;
	TrackWord *insWords = NULL;
	Position xList, yList;

	XtVaGetValues(wordsList, XtNx, &xList, XtNy, &yList, NULL);
	if((CurrentWords_ptr != NULL)?
			(CurrentWords_ptr->trackWords != NULL):(0)) {
		trackWords_ptr_ptr = 
					(CurrentWords_ptr->trackWords+CurrentWordsTrack-1);
		if(CurrentWordsTrack <= CurrentWords_ptr->tracks) {
			currentWords_ptr_ptr = 
					wordsptrCountSearch(trackWords_ptr_ptr, wordsIndex);
			if(currentWords_ptr_ptr != NULL) {
				insWords = trackWordAlloc();
				if(insWords != NULL) {
					insWords->wordTime = wordsNoneTime;
					insWordsString = (char*)malloc(1);
					if(insWordsString != NULL) {
						*insWordsString = '\0';
						insWords->next_ptr = *currentWords_ptr_ptr;
						*currentWords_ptr_ptr = insWords;
						while(insWords->next_ptr != NULL) {
							insWords->word = insWords->next_ptr->word;
							insWords = insWords->next_ptr;
						}
						insWords->word = insWordsString;
						makeTrackWords(CurrentWordsTrack);
					} else {
						wordRelease(insWords);
					}
				}
			}
		}
		if(wordsIndex < arrayCount((XtPointer)currentWordList) - 1) {
			WordsScroll(-yList);
			XawListHighlight(wordsList, wordsIndex);
			WordsSelect(wordsList, NULL, XawListShowCurrent(wordsList));
		}
	}
}

/***************************************************************************
 *	WordsTimeDel: Ԥ˱ջ֤ơʹߤιԤؤ餹
 *	
 *		void WordsTimeDel(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsTimeDel(Widget w, XtPointer client_data, XtPointer call_data)
{
	String delWordsString, nextWordsString;
	static struct cd_time wordsNoneTime = {EOF,EOF,EOF};
	TrackWord **currentWords_ptr_ptr, **trackWords_ptr_ptr = NULL;
	TrackWord *delWords = NULL, **reconnect_ptr_ptr;
	Position xList, yList;

	XtVaGetValues(wordsList, XtNx, &xList, XtNy, &yList, NULL);
	if((CurrentWords_ptr != NULL)?
			(CurrentWords_ptr->trackWords != NULL):(0)) {
		trackWords_ptr_ptr = 
					(CurrentWords_ptr->trackWords+CurrentWordsTrack-1);
		if(CurrentWordsTrack <= CurrentWords_ptr->tracks) {
			reconnect_ptr_ptr = currentWords_ptr_ptr = 
					wordsptrCountSearch(trackWords_ptr_ptr, wordsIndex);
			if(currentWords_ptr_ptr != NULL) {
				delWords = *currentWords_ptr_ptr;
				delWordsString = (*currentWords_ptr_ptr)->word;
				while((*currentWords_ptr_ptr)->next_ptr != NULL) {
					nextWordsString = (*currentWords_ptr_ptr)->next_ptr->word;
					(*currentWords_ptr_ptr)->next_ptr->word = delWordsString;
					delWordsString = nextWordsString;
					currentWords_ptr_ptr = &(*currentWords_ptr_ptr)->next_ptr;
				}
				if(strlen((*currentWords_ptr_ptr)->word) != 0) {
					(*currentWords_ptr_ptr)->next_ptr = trackWordAlloc();
					if((*currentWords_ptr_ptr)->next_ptr != NULL) {
						(*currentWords_ptr_ptr)->next_ptr->wordTime = wordsNoneTime;
						(*currentWords_ptr_ptr)->next_ptr->word = delWordsString;
					}
#ifdef	NEW_IMPLEMENT
				} else {
					wordRelease(*currentWords_ptr_ptr);
					*currentWords_ptr_ptr = NULL;
#endif	/*NEW_IMPLEMENT*/
				}
				*reconnect_ptr_ptr = (*reconnect_ptr_ptr)->next_ptr;
				delWords->word = NULL;
				wordRelease(delWords);
				makeTrackWords(CurrentWordsTrack);
			}
		}
		if(wordsIndex < arrayCount((XtPointer)currentWordList) - 1) {
			WordsScroll(-yList);
			XawListHighlight(wordsList, wordsIndex);
			WordsSelect(wordsList, NULL, XawListShowCurrent(wordsList));
		}
	}
}

/***************************************************************************
 *	WordsSelect: ץࡦꥹȤΥȥåܤ򤵤줿
 *	
 *		void (Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsSelect(Widget w, XtPointer client_data, XtPointer call_data)
{
	XawListReturnStruct *list_ptr = (XawListReturnStruct*)call_data;
	TrackWord *currentWords;
	
	XtSetSensitive(wordsFlashing, False);
	wordsIndex = list_ptr->list_index;
	if(CurrentWords_ptr != NULL) {
		if(CurrentWordsTrack > 0) {
			currentWords = 
				wordCountSearch(
					*(CurrentWords_ptr->trackWords + CurrentWordsTrack - 1), 
												list_ptr->list_index);
			if(currentWords != NULL) {
				wordsJumpTime = currentWords->wordTime;
				XtVaSetValues(wordsUnselect, XtNstate, True, NULL);
				XtSetSensitive(wordsUnselect, True);
			}
		}
	}
}

/***************************************************************************
 *	WordsJump: λ쥸פԤ
 *	
 *		void WordsJump(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsJump(Widget w, XtPointer client_data, XtPointer call_data)
{
	int status;
	Cd_Order *newCdOrder_ptr;
	struct cdda_play wordsJumpPlay;
	extern int CdTrack;
	extern int PlayingMode;
	extern struct cd_toc CddaToc;
	extern Cd_Order *CdOrder_ptr;
	extern int CounterMode;
	extern Widget pauseButton, play;

	XtSetSensitive(wordsFlashing, True);
	newCdOrder_ptr = time_order_search(&wordsJumpTime, CdOrder_ptr);
	if(newCdOrder_ptr != NULL) {
		CdOrder_ptr = newCdOrder_ptr;
		if(PlayingMode == PAUSE)
			XtVaSetValues(pauseButton, XtNstate, False, NULL);
		XtVaSetValues(play, XtNstate, True, NULL);
		wordsJumpPlay = CdOrder_ptr->play_info;	/* Ͽ */
		wordsJumpPlay.start = wordsJumpTime;
		CdTrack = get_track_no(&wordsJumpPlay.start, &CddaToc);
		status = cd_play2(&wordsJumpPlay);		/*  */
#ifdef	GENERAL
		if(status == 0) {
			trayManagerOff();
		}
#endif	/*GENERAL*/
		CounterControl(CounterMode, NULL);
		PlayingMode = PLAY;
		XtVaSetValues(wordsUnselect, XtNstate, False, NULL);
		XtSetSensitive(wordsUnselect, False);
	}
}

/***************************************************************************
 *	WordsUnselect: ץࡦꥹȤΥȥåܤ
 *	
 *		void WordsUnselect(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsUnselect(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtSetSensitive(wordsFlashing, True);
	XawListUnhighlight(wordsList);
	XtVaSetValues(wordsUnselect, XtNstate, False, NULL);
	XtSetSensitive(wordsUnselect, False);
}

/***************************************************************************
 *	WordsTrackDec: λ줬ɽƤȥå򣱤ˤ
 *	
 *		void WordsTrackDec(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsTrackDec(Widget w, XtPointer client_data, XtPointer call_data)
{
	if(CurrentWords_ptr != NULL) {
		if(CurrentWordsTrack > 1) {
			XtVaSetValues(wordsSyncronize, XtNstate, False, NULL);
			--CurrentWordsTrack;
			makeTrackWords(CurrentWordsTrack);
		}
	}
}

/***************************************************************************
 *	WordsTrackInc: λ줬ɽƤȥå򣱤ĸˤ
 *	
 *		void WordsTrackInc(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsTrackInc(Widget w, XtPointer client_data, XtPointer call_data)
{
	if(CurrentWords_ptr != NULL) {
		if(CurrentWordsTrack < CurrentWords_ptr->tracks) {
			XtVaSetValues(wordsSyncronize, XtNstate, False, NULL);
			++CurrentWordsTrack;
			makeTrackWords(CurrentWordsTrack);
		}
	}
}

/***************************************************************************
 *	WordsEditable: λԽǽON/OFF
 *	
 *		void WordsEditable(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsEditable(Widget w, XtPointer client_data, XtPointer call_data)
{
	Boolean editMode;

	XtVaGetValues(w, XtNstate, &editMode, NULL);
	if(editMode != False) {
		/***********************************
		 *	λԽǽ ON ˤ
		 ***********************************/
		XtSetSensitive(wordsPopdown, False);
		XtSetSensitive(wordsSave, ((app_data.read_only)?(False):(True)));
		XtSetSensitive(wordsLoad, True);
		XtSetSensitive(wordsFilename, True);
		XtSetSensitive(wordsSetTiming, True);
		XtSetSensitive(wordsInsTiming, True);
		XtSetSensitive(wordsDelTiming, True);
		XtSetSensitive(wordsInsSpace, True);
		XtSetSensitive(wordsDecSec, True);
		XtSetSensitive(wordsIncSec, True);
		XtSetSensitive(wordsEdit, True);
		XtVaSetValues(wordsDecSec, XtNbitmap, vdown_pixmap, NULL);
		XtVaSetValues(wordsIncSec, XtNbitmap, vup_pixmap, NULL);
	} else {
		/***********************************
		 *	λԽǽ OFF ˤ
		 ***********************************/
		XtSetSensitive(wordsPopdown, True);
		XtSetSensitive(wordsSave, False);
		XtSetSensitive(wordsLoad, False);
		XtSetSensitive(wordsFilename, False);
		XtSetSensitive(wordsSetTiming, False);
		XtSetSensitive(wordsInsTiming, False);
		XtSetSensitive(wordsDelTiming, False);
		XtSetSensitive(wordsInsSpace, False);
		XtSetSensitive(wordsDecSec, False);
		XtSetSensitive(wordsIncSec, False);
		XtSetSensitive(wordsEdit, False);
		XtVaSetValues(wordsDecSec, XtNbitmap, vdwDisablePixmap, NULL);
		XtVaSetValues(wordsIncSec, XtNbitmap, vupDisablePixmap, NULL);
	}
}

/***************************************************************************
 *	makeTrackWords: λ󥦥ɥ򹹿
 *	
 *		void makeTrackWords(int track);
 *	
 *		int track;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void makeTrackWords(int track)
{
	Boolean eject_flag;
	extern Widget eject;

	XtVaGetValues(eject, XtNstate, &eject_flag, NULL);
	if(CurrentWords_ptr != NULL) {
		strings_free(currentWordList);
		currentWordList = NULL;
		if(CurrentWords_ptr->trackWords != NULL) {
			track -= (track > 0);
			XtVaSetValues(wordsView, XtNallowVert, False, NULL);
			currentWordList = makeWords(*(CurrentWords_ptr->trackWords + track));
			XtVaSetValues(wordsTitle, XtNlabel, 
					cdljc((CurrentDisc_ptr->track_ptr+track)->trackTitle), NULL);
			if(*(CurrentWords_ptr->trackWords + track) != NULL) {
				XtSetSensitive(wordsList, !eject_flag);
			} else {
				XtSetSensitive(wordsList, False);
			}
		}
		XtVaSetValues(wordsUnselect, XtNstate, False, NULL);
		XtSetSensitive(wordsUnselect, False);
		XtSetSensitive(wordsFlashing, True);
		if(printableWordList != NULL) {
#ifdef	JA_DEBUG
			printf("***********strings_free(printableWordList);************\n");
#endif	/*JA_DEBUG*/
			strings_free(printableWordList);
		}
		printableWordList = 
				strArray2jcnvAndNew((const char**)currentWordList, 
												wordFileEncode, JaLoacle);

#ifdef	JA_DEBUG
		printf("printableWordListis %p\nTOP:%s\n", 
				printableWordList, *printableWordList);
		{
			int counter;

			for(counter = 0;counter < arrayCount((XtPointer)currentWordList);++counter) {
				printf("<src:%s>\n", *(currentWordList+counter));
			}
		}
#ifdef	JA_DEBUG2
		{
			int counter;

			for(counter = 0;counter < arrayCount((XtPointer)printableWordList);++counter) {
				printf("<dst:%s>\n", *(printableWordList+counter));
			}
		}
#endif	/*JA_DEBUG2*/
#endif	/*JA_DEBUG*/
#ifndef	FINISHED
		if(wordsListArray != NULL) {
			wordsListArray = printableWordList;
		} else {
			XawListChange(wordsList, printableWordList, 
					arrayCount((XtPointer)printableWordList), 0, True);
		}
	/*
	 *	if(wordsHeight > 0 ) {
	 *	} else {
	 *		wordsListArray = printableWordList;
	 *	}
	 */
#else
		XawListChange(wordsList, printableWordArray, 
					arrayCount((XtPointer)printableWordArray), 0, True);
		XawListChange(wordsList, currentWordList, 
						arrayCount((XtPointer)currentWordList), 0, True);
#ifdef	JA_DEBUG
	{
		int counter;
		int limit = arrayCount((XtPointer)printableWordList);

		printf("--------%s(%dline%s.)--------\n", 
			cdljc((CurrentDisc_ptr->track_ptr+track)->trackTitle), 
									limit, ((limit > 1)?("s"):("")));
		for(counter = 0;counter <= limit;++counter) {
			printf("#%d:[%p]:%s\n", counter, 
				printableWordArray[counter], printableWordArray[counter]);
		printf("--------%s(%dline%s.)--------\n", 
			cdljc((CurrentDisc_ptr->track_ptr+track)->trackTitle), 
									limit, ((limit > 1)?("s"):("")));
		}
	}
#endif	/*JA_DEBUG*/
#endif	FINISHED
		XtVaSetValues(wordsView, XtNallowVert, True, NULL);
	}
}

/***************************************************************************
 *	makeDiscWords: ǥ󥦥ɥ򹹿
 *	
 *		void makeDiscWords(void);
 *	
 *		void;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void makeDiscWords(void)
{
	char *filename, wordsName[1024];
	FILE *fp;
	static char *wordsSuffixList[] = {".wrd", NULL};
	
	if(CurrentDisc_ptr != NULL) {
		if(CurrentDisc_ptr->lyricsFile != NULL) {
		/*if(CurrentDisc_ptr->lyricsFile[0] != '\0') {}*/
			filename = searchFileName(app_data.wordsDirpath, 
				CurrentDisc_ptr->lyricsFile, (const char**)wordsSuffixList);
			sprintf(wordsName, "%.512s/%.500s", 
				app_data.wordsDirpath, ((filename != NULL)?(filename):("")));
#ifdef  XAW_BUG
			XtVaSetValues(wordsFilename, XtNstring, 
											XtNewString(wordsName), NULL);
#else
			XtVaSetValues(wordsFilename, XtNstring, wordsName, NULL);
#endif  /*XAW_BUG*/
			if(filename != NULL) {
				if((fp = fopen(wordsName, "rb")) != NULL) {
					DiscWordRelease(CurrentWords_ptr);
					CurrentWords_ptr = NULL;
					CurrentWords_ptr = DiscWordAlloc(CurrentDisc_ptr->tracks);
					getWord(CurrentWords_ptr, fp);
					wordFileEncode = checkEncode((void*)CurrentWords_ptr, 
											wordStringOut, wordNextString);
					/*putWord(CurrentWords_ptr, stdout);*/
					fclose(fp);
				}
				free(filename);
			} else {
				DiscWordRelease(CurrentWords_ptr);
				CurrentWords_ptr = DiscWordAlloc(CurrentDisc_ptr->tracks);
			}
			if(wordFileEncode == NoJapanese) {
				wordFileEncode = JaSJIS;
			}
			CurrentWordsTrack = 1;
			makeTrackWords(CurrentWordsTrack);
		}
	}
}

/***************************************************************************
 *	WordsGeometry: ץࡦꥹȤΥȥåܤ򤵤줿
 *	
 *		void WordsGeometry(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/

/***************************************************************************
 *	WordsGeometry: 
 *	
 *		void WordsGeometry(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsGeometry(Widget w, XtPointer client_data, XtPointer call_data)
{
	XawPannerReport *report_ptr = (XawPannerReport*)call_data;

	wordsGeometry = *report_ptr;
	
#ifdef	NEW_IMPLEMENT
	printf("WordsGeometry: changed = %#x, slider=%dx%d+%d+%d/%dx%d\n", 
			report_ptr->changed, report_ptr->slider_width, report_ptr->slider_height, 
			report_ptr->slider_x, report_ptr->slider_y, 
					report_ptr->canvas_width, report_ptr->canvas_height);
#endif	/*NEW_IMPLEMENT*/
}

/***************************************************************************
 *	WordsScroll: λꥹȤΥꤹ
 *	
 *		void WordsScroll(int y);
 *	
 *		int y;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsScroll(int y)
{
	int all, dispLines;
	int shiftable, shift = 0;

	all = arrayCount((XtPointer)currentWordList);
	dispLines = all * wordsGeometry.slider_height
										/ wordsGeometry.canvas_height;
	if(dispLines < all) {
		shiftable = wordsGeometry.canvas_height - wordsGeometry.slider_height;
		switch((y >= 0) + (y > shiftable)) {
		case 0:
			shift = 0;
			break;
		case 1:
			shift = y;
			break;
		case 2:
			shift = shiftable;
			break;
		}
		XawViewportSetCoordinates(wordsView, 0, shift);
	}
}

/***************************************************************************
 *	WordsSyncronizeGeometry: λꥹȤΥȥƱ
 *	
 *		void WordsSyncronizeGeometry(int index);
 *	
 *		int index;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsSyncronizeGeometry(int index)
{
	int all, dispLines;
	int shiftable, shift = 0;

	all = arrayCount((XtPointer)currentWordList);
	dispLines = all * wordsGeometry.slider_height
										/ wordsGeometry.canvas_height;
	if(dispLines < all) {
		shiftable = wordsGeometry.canvas_height - wordsGeometry.slider_height;
		switch((index >= dispLines/2) + 
				(index > (all - dispLines/2))) {
		case 0:
			shift = 0;
			break;
		case 1:
			shift = shiftable * (index - dispLines/2)/(all - dispLines);
			break;
		case 2:
			shift = shiftable;
			break;
		}
		XawViewportSetCoordinates(wordsView, 0, shift);
	}
}

/***************************************************************************
 *	WordsFlashing: Υץΰ֥եå夵
 *	
 *		void WordsFlashing(void);
 *	
 *		void;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void WordsFlashing(void)
{
	Boolean flashingMode, syncronizeMode;
	int index, tmpFlashing = EOF;
	static int old_index;
	static Boolean flashingFlag = False;
	extern struct cd_subq CurrentSubq;
	
	XtVaGetValues(wordsFlashing, XtNstate, &flashingMode, NULL);
	XtVaGetValues(wordsSyncronize, XtNstate, &syncronizeMode, NULL);
	if(syncronizeMode != False) {
		syncronizeMode = XtIsSensitive(wordsSyncronize);
	}
	if(flashingMode != False)
		flashingMode = XtIsSensitive(wordsFlashing);

	if(syncronizeMode != False && CurrentSubq.track != CurrentWordsTrack) {
		if(CurrentSubq.track > 0 && 
				CurrentSubq.track <= ((CurrentWords_ptr != NULL)?
										(CurrentWords_ptr->tracks):(0))) {
			CurrentWordsTrack = CurrentSubq.track;
			makeTrackWords(CurrentWordsTrack);
		}
	}
	if(flashingMode == True && CurrentWords_ptr != NULL && 
							CurrentSubq.track == CurrentWordsTrack) {
		flashingFlag = ((flashingFlag == False)?(True):(False));
		index = wordsTimeSearch(
				*(CurrentWords_ptr->trackWords + CurrentWordsTrack - 1), 
													&CurrentSubq.time);
		if(index == EOF || index != old_index) {
			tmpFlashing = ((index != EOF)?(index != old_index):(False));
			if(syncronizeMode != False) {
				WordsSyncronizeGeometry(index);
			}
		}
		if((tmpFlashing != EOF)?(tmpFlashing):(flashingFlag))
			XawListHighlight(wordsList, index);
		else
			XawListUnhighlight(wordsList);
		old_index = index;
	}
}

/***************************************************************************
 *	wordsEditString: λΥƥʬʸ󲽤
 *	
 *		String wordsEditString(TrackWord *lyric);
 *	
 *		TrackWord *lyric;	ʸ󲽤λ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
String wordsEditString(TrackWord *lyric)
{
	int counter;
	size_t length;
	String wordsString;
	
	length = wordsLength(lyric);
	wordsString = XtMalloc(length + 1);
	for(counter = 0, *wordsString = '\0';
			lyric != NULL && (counter + strlen(lyric->word) + 1) <= length;
			counter += strlen(lyric->word) + 1, lyric = lyric->next_ptr) {
		strcat(wordsString, lyric->word);
		if(lyric->next_ptr != NULL)
			strcat(wordsString, "\n");
	}
	return(wordsString);
}

/***************************************************************************
 *	WordsSetMaxHeight: 
 *	
 *		void WordsSetMaxHeight(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void WordsSetMaxHeight(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtVaGetValues(wordsView, XtNheight, &wordsHeight, NULL);
	XawPanedSetMinMax(wordsView, 1, wordsHeight);
}

/***************************************************************************
 *	WordsMaxLock: 
 *	
 *		void WordsMaxLock(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void WordsMaxLock(Widget w, XtPointer client_data, XtPointer call_data)
{
	Boolean lockFlag;
	Dimension nowWordsWidth, nowWordsHeight, nowShellWidth, nowShellHeight;

	XtVaGetValues(w, XtNstate, &lockFlag, NULL);
	if(lockFlag) {
		XtVaGetValues(wordsShell, 
				XtNwidth, &nowShellWidth, XtNheight, &nowShellHeight, NULL);
		XtVaGetValues(wordsView, 
				XtNwidth, &nowWordsWidth, XtNheight, &nowWordsHeight, NULL);
		XawPanedSetRefigureMode(wordsBlocks, False);
		if(wordsHeight < nowWordsHeight) {
			XtMakeResizeRequest(wordsShell, nowShellWidth, 
					nowShellHeight + wordsHeight - nowWordsHeight,
									&nowShellWidth, &nowShellHeight);
			XtMakeResizeRequest(wordsView, nowWordsWidth, wordsHeight,
									&nowWordsWidth, &nowWordsHeight);
		}
		XawPanedSetMinMax(wordsView, 1, wordsHeight);
		XawPanedSetRefigureMode(wordsBlocks, True);
	} else {
		XawPanedSetRefigureMode(wordsView, False);
		XawPanedSetMinMax(wordsView, 1, ~0);
		/*XawPanedSetRefigureMode(wordsView, True);*/
	}
}

/***************************************************************************
 *	WordsEdit: ףңĥե񤭹
 *	
 *		void WordsEdit(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ʲεǽޤ
 *		ϿEnter˥⡼ɤ
 *		ףңĥե񤭹ࡣ
 *		
 ***************************************************************************/
/*ARGSUSED*/
void WordsEdit(Widget w, XtPointer client_data, XtPointer call_data)
{
	String textString;
	TrackWord *currentWords;
	
	XtSetSensitive(wordsFlashing, False);
	XtVaSetValues(wordsSyncronize, XtNstate, False, NULL);
	if(CurrentWords_ptr != NULL) {
		if(CurrentWordsTrack > 0) {
			currentWords = 
				*(CurrentWords_ptr->trackWords + CurrentWordsTrack - 1); 
			if(currentWords != NULL) {
				textString = wordsEditString(currentWords);
#ifdef  XAW_BUG
				XtVaSetValues(wordsTEdit, XtNstring, 
					string2otherEncodeNewString(textString, 
						jcodesets[wordFileEncode], jencodes[JaLoacle]), NULL);
#else
				XtVaSetValues(wordsTEdit, XtNstring, 
											XtNewString(textString), NULL);
				XtVaSetValues(wordsTEdit, XtNstring, textString, NULL);
#endif  /*XAW_BUG*/
			}
		}
	}
}

/***************************************************************************
 *	WordsTInit: λƥȤʥȥΤߤˡˤ
 *	
 *		void WordsTInit(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void WordsTInit(Widget w, XtPointer client_data, XtPointer call_data)
{
	int track;

	if(CurrentWordsTrack > 0) {
		track = CurrentWordsTrack - 1;
#ifdef  XAW_BUG
		XtVaSetValues(wordsTEdit, XtNstring, 
			XtNewString(cdljc((CurrentDisc_ptr->track_ptr+track)->trackTitle)), NULL);
#else
		XtVaSetValues(wordsTEdit, XtNstring, 
			XtNewString((CurrentDisc_ptr->track_ptr+track)->trackTitle), NULL);
		XtVaSetValues(wordsTEdit, XtNstring, 
				(CurrentDisc_ptr->track_ptr + track)->trackTitle, NULL);
#endif  /*XAW_BUG*/
	}
}

/***************************************************************************
 *	WordsTextTest: λ󤬹Ƥ뤫ɤĴ٤
 *	
 *		int WordsTextTest(void);
 *	
 *		void;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
#define lyricString(l)	(((l) != NULL && (l)->word != NULL)?((l)->word):"")

int WordsTextTest(void)
{
	int flag = 0;
	String textString;
	String wrdEncodeTextString;
	TrackWord *newLyric = NULL;
	TrackWord **lyric_ptr_ptr;

	/*
	printf("%d -- %d\n", JaLoacle, wordFileEncode);
	 */
	XtVaGetValues(wordsTEdit, XtNstring, &textString, NULL);
	if(CurrentWords_ptr == NULL) {
		CurrentWords_ptr = DiscWordAlloc(CurrentDisc_ptr->tracks);
	}
	if(CurrentWords_ptr != NULL) {
		if(CurrentWords_ptr->trackWords != NULL) {
			wrdEncodeTextString = 
					string2otherEncodeNewString(textString, 
							jcodesets[JaLoacle], jencodes[wordFileEncode]);
			remakeEditWords(&newLyric, wrdEncodeTextString);
			XtFree(wrdEncodeTextString);
			lyric_ptr_ptr = 
					CurrentWords_ptr->trackWords + CurrentWordsTrack - 1;
			/*
			printf("Old: %s\nNew: %s\n", lyricString(*lyric_ptr_ptr), lyricString(newLyric));
			 */
			flag = lyricCmp(*lyric_ptr_ptr, newLyric);
		}
	}
	return(flag);
}

/***************************************************************************
 *	WordsTEnter: λƥȤλʥȥåˤ
 *	
 *		void WordsTEnter(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void WordsTEnter(Widget w, XtPointer client_data, XtPointer call_data)
{
	int flag;
	String textString;
	String wrdEncodeTextString;
	TrackWord **lyric_ptr_ptr;
	extern Widget eject;

	XtVaGetValues(wordsTEdit, XtNstring, &textString, NULL);
	if(CurrentWords_ptr == NULL) {
		CurrentWords_ptr = DiscWordAlloc(CurrentDisc_ptr->tracks);
	}
	if(CurrentWords_ptr != NULL) {
		if(CurrentWords_ptr->trackWords != NULL) {
			lyric_ptr_ptr = 
					CurrentWords_ptr->trackWords + CurrentWordsTrack - 1;
			wrdEncodeTextString = 
					string2otherEncodeNewString(textString, 
							jcodesets[JaLoacle], jencodes[wordFileEncode]);
			flag = remakeEditWords(lyric_ptr_ptr, wrdEncodeTextString);
			makeTrackWords(CurrentWordsTrack);
			XtFree(wrdEncodeTextString);
			XtVaSetValues(eject, XtNbitmap, ejectDisable_pixmap, NULL);
			XtSetSensitive(eject, False);
		}
	}
}

/***************************************************************************
 *	WordsTWrdLoad: λǡ(WRD)եɤ߹
 *	
 *		DiscWord *WordsTWrdLoad(FILE *fp);
 *	
 *		FILE *fp;
 *	֤
 *		
 *	
 *		ץࡦꥹȤɤ߹ߡ顼ʳʤ顢ץࡦꥹȡ
 *		ɥ򹹿롣
 *		
 ***************************************************************************/
/*ARGSUSED*/
DiscWord *WordsTWrdLoad(FILE *fp)
{
	int tracks;
	DiscWord *fWords = NULL;
	
	tracks = getWordTracks(fp);
	fWords = DiscWordAlloc(tracks);
	fseek(fp, 0, SEEK_SET);
	getWord(fWords, fp);
	return(fWords);
}

/***************************************************************************
 *	diskWordsTitles: ϿѤ߲λƬԥꥹȤ
 *	
 *		char **diskWordsTitles(const DiscWord *wordsInfo);
 *	
 *		const DiscWord *wordsInfo;
 *	֤
 *		NULL		ɤΥȥåˤλ¸ߤʤ
 *		NULLʳ	λ¸ߥȥåƬԤʸNULLü
 *	
 *		
 ***************************************************************************/
char **diskWordsTitles(const DiscWord *wordsInfo)
{
	int counter;
	int wordsTracks;
	char **titles = NULL;
	char *topLine;
	char titleBuf[256];

	for(counter = 0, wordsTracks = 0;counter < wordsInfo->tracks;++counter) {
		if(*(wordsInfo->trackWords + counter) != NULL) {
			++wordsTracks;
		}
	}
	if(wordsTracks > 0) {
		titles = (char**)XtMalloc(sizeof(char*) * (wordsTracks + 1));
	}
	if(titles != NULL) {
		for(counter = 0, wordsTracks = 0;
								counter < wordsInfo->tracks;++counter) {
			if(*(wordsInfo->trackWords + counter) != NULL) {
				topLine = (*(wordsInfo->trackWords + counter))->word;
				sprintf(titleBuf, "Track %d : %.*s", counter + 1, 
					(int)sizeof(titleBuf)-20, ((topLine != NULL)?(topLine):("")));
				*(titles + wordsTracks) = 
						string2otherEncodeNewString(titleBuf, 
							jcodesets[wordFileEncode], jencodes[JaLoacle]);
				++wordsTracks;
			}
		}
		*(titles + wordsTracks) = NULL;
	}
	return(titles);
}

/***************************************************************************
 *	**diskWordsTitles: 
 *	
 *		char **diskWordsTitles(const DiscWord *wordsInfo);
 *	
 *		const DiscWord *wordsInfo;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/

/***************************************************************************
 *	*dWrdTitles2Track: 
 *	
 *		TrackWord *dWrdTitles2Track(const DiscWord *wordsInfo, int selectedNo);
 *	
 *		const DiscWord *wordsInfo;
 *		int selectedNo;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
TrackWord *dWrdTitles2Track(const DiscWord *wordsInfo, int selectedNo)
{
	int counter;
	int wordsTracks;
	TrackWord *selected = NULL;

	for(counter = 0, wordsTracks = 0;counter < wordsInfo->tracks;++counter) {
		if(*(wordsInfo->trackWords + counter) != NULL) {
			if(wordsTracks == selectedNo) {
				selected = *(wordsInfo->trackWords + counter);
				break;
			}
			++wordsTracks;
		}
	}
	return(selected);
}

/***************************************************************************
 *	trackSelectSubmit: WRD λΥƥɤ߹ߡȥå
 *	
 *		void trackSelectSubmit(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;	ݥ󥿥󥯲줿ݥ
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ݥ󥿥󥯲줿ݥ
 *		ʲΥݥ󥿤˳ǼƤ
 *		1 λWRD ե
 *		2 ȥåѥ٥륦å
 *		3 WRD եΥ󥳡ɾ
 *		4 ȥåѥ٥ꥹȡʲλƬԡˡNULLüΥݥ
 *		5 οƥå
 *		6 Υå
 *		
 ***************************************************************************/
void trackSelectSubmit(Widget w, XtPointer client_data, XtPointer call_data)
{
	int textEncode;
	String textString, cnvTextString;
	Widget trackSelector;
	Widget trackList = NULL;
	XawListReturnStruct *selectNow = NULL;
	TrackWord *selected;
	DiscWord *textDiskWrd = NULL;
	PointorsLink *linkBuffer = (PointorsLink*)client_data;

	if(linkBuffer != NULL) {
		/* λWRD եˡФ */
		textDiskWrd = (DiscWord*)cutoffPointorsLink(&linkBuffer);
	}
	if(linkBuffer != NULL) {
		/* ȥåѥ٥륦åȡФ */
		trackList = (Widget)cutoffPointorsLink(&linkBuffer);
	}
	if(linkBuffer != NULL) {
		/* WRD եΥ󥳡ɾ󡾼Ф */
		textEncode = (int)cutoffPointorsLink(&linkBuffer);
		/*****************************************************
		 *	WRD եβλƥȣʬμФϿ
		 *****************************************************/
		selectNow = XawListShowCurrent(trackList);
		if(textDiskWrd != NULL && selectNow->list_index != XAW_LIST_NONE) {
			selected = dWrdTitles2Track(textDiskWrd, selectNow->list_index);
			textString = wordsEditString(selected);
			cnvTextString = string2otherEncodeNewString(textString, 
								jcodesets[textEncode], jencodes[JaLoacle]);
			XtVaSetValues(wordsTEdit, XtNstring, cnvTextString, NULL);
			XtFree(textString);
		}
	}
	DiscWordRelease(textDiskWrd);
	if(linkBuffer != NULL) {
		/* ȥåѥ٥ꥹȡФ */
		nullTerminatedPointerArrayFree((void**)cutoffPointorsLink(&linkBuffer));
	}
	if(linkBuffer != NULL) {
		/* οƥåȡФ */
		XtSetSensitive((Widget)cutoffPointorsLink(&linkBuffer), True);
	}
	if(linkBuffer != NULL) {
		/* ΥåȡФ */
		trackSelector = (Widget)cutoffPointorsLink(&linkBuffer);
		XtPopdown(trackSelector);
		XtDestroyWidget(trackSelector);
	}
	VaDestroyPointorsLink(linkBuffer);
}

/***************************************************************************
 *	trackSelectCancel: WRD λΥƥɤ߹ߡ򥭥󥻥
 *	
 *		void trackSelectCancel(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ݥ󥿥󥯲줿ݥ
 *		ʲΥݥ󥿤˳ǼƤ
 *		1 λWRD ե
 *		2 ȥåѥ٥륦å
 *		3 WRD եΥ󥳡ɾ
 *		4 ȥåѥ٥ꥹȡʲλƬԡˡNULLüΥݥ
 *		5 οƥå
 *		6 Υå
 *		
 ***************************************************************************/
void trackSelectCancel(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget trackSelector;
	PointorsLink *linkBuffer = (PointorsLink*)client_data;

	if(linkBuffer != NULL) {
		/* λWRD եˡФ */
		DiscWordRelease((DiscWord*)cutoffPointorsLink(&linkBuffer));
	}
	if(linkBuffer != NULL) {
		/* ȥåѥ٥륦åȡФ */
		(void)cutoffPointorsLink(&linkBuffer);
	}
	if(linkBuffer != NULL) {
		/* WRD եΥ󥳡ɾ󡾼Ф */
		(void)cutoffPointorsLink(&linkBuffer);
	}
	if(linkBuffer != NULL) {
		/* ȥåѥ٥ꥹȡФ */
		nullTerminatedPointerArrayFree((void**)cutoffPointorsLink(&linkBuffer));
	}
	if(linkBuffer != NULL) {
		/* οƥåȡФ */
		XtSetSensitive((Widget)cutoffPointorsLink(&linkBuffer), True);
	}
	if(linkBuffer != NULL) {
		/* ΥåȡФ */
		trackSelector = (Widget)cutoffPointorsLink(&linkBuffer);
		XtPopdown(trackSelector);
	}
	VaDestroyPointorsLink(linkBuffer);
}

/***************************************************************************
 *	creatTrackSelector: 
 *	
 *		void creatTrackSelector(Widget parent, DiscWord *wordsInfo);
 *	
 *		Widget parent;
 *		DiscWord *wordsInfo;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void creatTrackSelector(Widget parent, DiscWord *wordsInfo, int encode)
{
	Widget trackSelector, trackSelectorArea;
	Widget trackSelectorLabel, trackView, trackList, trackSubmit;
	Widget trackCancel;
	PointorsLink *linkBuffer = NULL;
	char **titleList;

	trackSelector = XtVaCreatePopupShell(
				"trackSelector",
				topLevelShellWidgetClass,
				parent,
				NULL);

	trackSelectorArea = XtVaCreateManagedWidget(
				"trackSelectorArea",
				formWidgetClass,
				trackSelector,
				NULL);

	trackSelectorLabel = XtVaCreateManagedWidget(
				"trackSelectorLabel",
				labelWidgetClass,
				trackSelectorArea,
				NULL);

	trackView = XtVaCreateManagedWidget(
				"trackView", 				/* widget name   */
				viewportWidgetClass, 		/* widget class */
				trackSelectorArea,			/* parent widget */
				NULL); 						/* argument list */

	trackList = XtVaCreateManagedWidget(
				"trackList",
				listWidgetClass,
				trackView,
				NULL);

	trackSubmit = XtVaCreateManagedWidget(
				"trackSubmit",
				commandWidgetClass,
				trackSelectorArea,
				NULL);

	trackCancel = XtVaCreateManagedWidget(
				"trackCancel",
				commandWidgetClass,
				trackSelectorArea,
				NULL);

	titleList = diskWordsTitles(wordsInfo);
	XawListChange(trackList, titleList, 
								arrayCount((XtPointer)titleList), 0, True);
	VaCreatePointorsLink(&linkBuffer, 
			wordsInfo, trackList, encode, titleList, parent, trackSelector, NULL);
	XtAddCallback(trackSubmit, XtNcallback, trackSelectSubmit, linkBuffer);
	XtAddCallback(trackCancel, XtNcallback, trackSelectCancel, linkBuffer);
	XtRealizeWidget(trackSelector);
	XtPopup(trackSelector, XtGrabExclusive);
}

/***************************************************************************
 *	WordsTextLoad: λԽѤΥƥȥեɤ߹
 *	
 *		char *WordsTextLoad(FILE *fp);
 *	
 *		FILE *fp;
 *	֤
 *		λƥΡXtMalloc() ǳƤƤޤ
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
char *WordsTextLoad(FILE *fp)
{
	int len;
	char *status_ptr;
	unsigned char buffer[1024];
	String textString;
	TrackWord *currentWord, *wordsTop = NULL, **endWord_ptr_ptr;

	endWord_ptr_ptr = &wordsTop;
	do {
		status_ptr = fgets(buffer, sizeof(buffer), fp);
		if(status_ptr != NULL) {
			currentWord = trackWordAlloc();
			len = strlen(buffer);
			while((len > 0)?(iscntrl(buffer[len-1]) &&
								buffer[len-1]<0x80):(FALSE))
				--len;
			buffer[len] = '\0';
			currentWord->word = (char*)malloc(strlen(buffer) + 1);
			if(currentWord->word != NULL)
				strcpy(currentWord->word, buffer);
			*endWord_ptr_ptr = currentWord;
			endWord_ptr_ptr = &currentWord->next_ptr;
		}
	} while(status_ptr != NULL);
	textString = wordsEditString(wordsTop);
	wordLinkRelease(wordsTop);

	return(textString);
}

/***************************************************************************
 *	WordsTLoad: λԽѤΥƥȥեɤ߹
 *	
 *		void WordsTLoad(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void WordsTLoad(Widget w, XtPointer client_data, XtPointer call_data)
{
	int status;
	int textEncode;
	FILE *fp;
	String filename, textString;
	String cnvTextString;
	DiscWord *tmpDiscWord;

	XtVaGetValues(wordsTFilename, XtNstring, &filename, NULL);
	status = isWordsFile(filename);
	if((fp = fopen(filename, "rb")) != NULL) {
		switch(status) {
		default:		/* ꤵ줿ե뤬ףңĥեηǤʤ */
			textString = WordsTextLoad(fp);
			textEncode = checkEncode(textString, NULL, NULL);
			cnvTextString = string2otherEncodeNewString(textString, 
								jcodesets[textEncode], jencodes[JaLoacle]);
#ifdef  XAW_BUG
			XtVaSetValues(wordsTEdit, XtNstring, cnvTextString, NULL);
#else
			XtVaSetValues(wordsTEdit, XtNstring, 
									XtNewString(textString), NULL);
			XtVaSetValues(wordsTEdit, XtNstring, textString, NULL);
#endif  /*XAW_BUG*/
			break;
		case 0:			/* ꤵ줿ե뤬ףңĥե */
			tmpDiscWord =  WordsTWrdLoad(fp);
			textEncode = checkEncode((void*)tmpDiscWord, 
											wordStringOut, wordNextString);
			creatTrackSelector(w, tmpDiscWord, textEncode);
			break;
		}
	}
}

/***************************************************************************
 *	WordsTSave: ףңĥե񤭹
 *	
 *		void WordsTSave(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 ***************************************************************************/
/*ARGSUSED*/
void WordsTSave(Widget w, XtPointer client_data, XtPointer call_data)
{
	int status = 0;
	String filename;
	String textString;
	FILE *fp;

	if(app_data.read_only == False) {
		WordsDataError = NULL;
		XtVaGetValues(wordsTFilename, XtNstring, &filename, NULL);
		WordsDataError = filename;
		if((fp = fopen(filename, "w")) != NULL) {
			XtVaGetValues(wordsTEdit, XtNstring, &textString, NULL);
			fputs(textString, fp);
			fclose(fp);
		}
		switch(status) {
		case 0:
			break;
		case EOF:
			PopupMessage(WordsDataError);
			break;
		default:
			PopupSyserrMessage(WordsDataError);
			break;
		}
	}
}

/***************************************************************************
 *	VerifyYes: 
 *	
 *		void VerifyYes(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void VerifyYes(Widget w, XtPointer client_data, XtPointer call_data)
{
	if(verifyYesFunc != NULL)
		(*verifyYesFunc)(w, verifyShellPopdown.client_data, call_data);
	XtPopdown(verifyShell);
	XtSetSensitive(verifyShellPopdown.popupWidget, True);
}

/***************************************************************************
 *	VerifyNo: 
 *	
 *		void VerifyNo(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void VerifyNo(Widget w, XtPointer client_data, XtPointer call_data)
{
	if(verifyNoFunc != NULL)
		(*verifyNoFunc)(w, verifyShellPopdown.client_data, call_data);
	XtPopdown(verifyShell);
	XtSetSensitive(verifyShellPopdown.popupWidget, True);
}

/***************************************************************************
 *	VerifyCancel: 
 *	
 *		void VerifyCancel(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void VerifyCancel(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtPopdown(verifyShell);
	XtSetSensitive(verifyShellPopdown.popupWidget, True);
}

/***************************************************************************
 *	VerifyShellInit: ѤγǧѤΥνԤ
 *	
 *		void VerifyShellInit(Widget topLevel, Widget cd_panel);
 *	
 *		Widget topLevel;	ƾ̤Υå
 *		Widget cd_panel;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void VerifyShellInit(Widget topLevel, Widget cd_panel)
{
	Widget verifyBlocks;
	Widget verifyYes, verifyNo, verifyCancel;

	/***************************************
	 *	ãģ̥ǡδϢå
	 ***************************************/
	verifyShell = XtVaCreatePopupShell(
			"verifyShell",
			transientShellWidgetClass,
			topLevel,
			NULL
			);

	verifyBlocks = XtVaCreateManagedWidget(
			"verifyBlocks", 				/* widget name   */
			formWidgetClass, 				/* widget class */
			verifyShell, 					/* parent widget*/
			NULL 							/* argument list*/
			);

	verifyMessage = XtVaCreateManagedWidget(
			"verifyMessage", 				/* widget name   */
			labelWidgetClass, 				/* widget class */
			verifyBlocks, 					/* parent widget */
			NULL 							/* argument list */
			);
	
	verifyYes = XtVaCreateManagedWidget(
			"verifyYes", 					/* widget name   */
			commandWidgetClass, 			/* widget class */
			verifyBlocks, 					/* parent widget */
			NULL 							/* argument list */
			);
	
	verifyNo = XtVaCreateManagedWidget(
			"verifyNo", 					/* widget name   */
			commandWidgetClass, 			/* widget class */
			verifyBlocks, 					/* parent widget */
			NULL 							/* argument list */
			);
	
	verifyCancel = XtVaCreateManagedWidget(
			"verifyCancel", 				/* widget name   */
			commandWidgetClass, 			/* widget class */
			verifyBlocks, 					/* parent widget */
			NULL 							/* argument list */
			);
	
	XtAddCallback(verifyYes, XtNcallback, VerifyYes, NULL);
	XtAddCallback(verifyNo, XtNcallback, VerifyNo, NULL);
	XtAddCallback(verifyCancel, XtNcallback, VerifyCancel, NULL);
}

/***************************************************************************
 *	verifySet: ǧѥåϿ
 *	
 *		void verifySet(Widget popupButton, const String message, 
 *					XtPointer client_data, 
 *					void (*yesFunc)(Widget, XtPointer, XtPointer), 
 *					void (*noFunc)(Widget, XtPointer, XtPointer));
 *	
 *		Widget popupButton;
 *		const char *message;
 *		XtPointer client_data;
 *		void (*yesFunc)(Widget, XtPointer, XtPointer);
 *		void (*noFunc)(Widget, XtPointer, XtPointer);
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void verifySet(Widget popupButton, const char *message, 
					XtPointer client_data, 
						void (*yesFunc)(Widget, XtPointer, XtPointer), 
							void (*noFunc)(Widget, XtPointer, XtPointer))
{
	verifyYesFunc = yesFunc;
	verifyNoFunc  =  noFunc; 
	XtVaSetValues(verifyMessage, XtNlabel, message, XtNheight, 36, NULL);
	verifyShellPopdown.popupWidget = popupButton;
	verifyShellPopdown.client_data = client_data;
	anyWindowPopup(popupButton, verifyShell, NULL);
	XtPopup(verifyShell, XtGrabExclusive);
}

/***************************************************************************
 *	WordsTInitSet: 
 *	
 *		void WordsTInitSet(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		;"ߤβλƥȤ˴ޤ"
 ***************************************************************************/
/*ARGSUSED*/
void WordsTInitSet(Widget w, XtPointer client_data, XtPointer call_data)
{
	verifySet(w, keyword2mes("WrdEnterDestroy"), NULL, WordsTInit, NULL);
}

/***************************************************************************
 *	WordsTEnterPopdown: 
 *	
 *		void WordsTEnterPopdown(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void WordsTEnterPopdown(Widget w, XtPointer client_data, XtPointer call_data)
{
	PopdownTargetShell(wordsTPopdown, &wordsTShellPopdown, NULL);
	WordsTEnter(w, client_data, call_data);
}

/***************************************************************************
 *	WordsTPopdown: 
 *	
 *		void WordsTPopdown(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void WordsTPopdown(Widget w, XtPointer client_data, XtPointer call_data)
{
	PopdownTargetShell(wordsTPopdown, &wordsTShellPopdown, NULL);
}

/***************************************************************************
 *	WordsTPopdownSet: 
 *	
 *		void WordsTPopdownSet(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void WordsTPopdownSet(Widget w, XtPointer client_data, XtPointer call_data)
{
	if(WordsTextTest()) {
		verifySet(wordsTPopdown, keyword2mes("WrdEnterVerify"), 
				&wordsTShellPopdown, WordsTEnterPopdown, WordsTPopdown);
	} else {
		PopdownTargetShell(wordsTPopdown, &wordsTShellPopdown, NULL);
	}
}

/***************************************************************************
 *	WordsPopdown: 
 *	
 *		void WordsPopdown(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void WordsPopdown(Widget w, XtPointer client_data, XtPointer call_data)
{
	extern Widget eject;

	XtVaSetValues(eject, XtNbitmap, eject_pixmap, NULL);
	XtSetSensitive(eject, True);
}

/***************************************************************************
 *	wordsCompactDiscOut: ǥ򴹤ȼCompact Disc Dataɤؤν
 *	
 *		void wordsCompactDiscOut(void);
 *	
 *		void;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void wordsCompactDiscOut(void)
{
	XtVaSetValues(wordsEditable, XtNstate, False, NULL);
	WordsEditable(wordsEditable, NULL, NULL);
	XtSetSensitive(wordsEditable, False);
	XtSetSensitive(wordsList, False);
	XtSetSensitive(wordsJump, False);
}

/***************************************************************************
 *	wordsCompactDiscIn: ǥ򴹤ȼCompact Disc Dataɤؤν򴹸
 *	
 *		void wordsCompactDiscIn(void);
 *	
 *		void;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void wordsCompactDiscIn(void)
{
	XtSetSensitive(wordsEditable, True);
	XtSetSensitive(wordsList, True);
	XtSetSensitive(wordsJump, True);
	XtSetSensitive(wordsFlashing, True);
}

/***************************************************************************
 *	WordsEditInit: ޥɡ˥塼ץࡦꥹȤνԤ
 *	
 *		void WordsEditInit(Widget topLevel, Widget cd_panel, Widget popupButton);
 *	
 *		Widget topLevel;
 *		Widget cd_panel;
 *		Widget popupButton;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsEditInit(Widget topLevel, Widget cd_panel, Widget popupButton)
{
	Widget wordsTEnter, wordsTInit, wordsTSave, wordsTLoad;
	Widget wordsTFileSelect;

	/***************************************
	 *	ãģ̥ǡδϢå
	 ***************************************/
	wordsTextShell = XtVaCreatePopupShell(
			"wordsTextShell",
			topLevelShellWidgetClass,
			topLevel,
			NULL
			);

	wordsTextBlocks = XtVaCreateManagedWidget(
			"wordsTextBlocks", 			/* widget name   */
			panedWidgetClass, 			/* widget class */
			wordsTextShell, 				/* parent widget*/
			NULL 						/* argument list*/
			);

	wordsTFileBlock = XtVaCreateManagedWidget(
			"wordsTFileBlock", 			/* widget name   */
			panedWidgetClass,	 		/* widget class */
			wordsTextBlocks, 			/* parent widget */
			XtNorientation, XtorientHorizontal,
			NULL 						/* argument list */
			);
	
	wordsTPopdown = XtVaCreateManagedWidget(
			"wordsTPopdown", 			/* widget name   */
			commandWidgetClass, 		/* widget class */
			wordsTFileBlock, 			/* parent widget */
			NULL 						/* argument list */
			);
	
	wordsTInit = XtVaCreateManagedWidget(
			"wordsTInit", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			wordsTFileBlock, 			/* parent widget */
			NULL 						/* argument list */
			);
	
	wordsTEnter = XtVaCreateManagedWidget(
			"wordsTEnter", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			wordsTFileBlock, 			/* parent widget */
			NULL 						/* argument list */
			);
	
	wordsTSave = XtVaCreateManagedWidget(
			"wordsTSave", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			wordsTFileBlock, 			/* parent widget */
			NULL 						/* argument list */
			);
	
	wordsTLoad = XtVaCreateManagedWidget(
			"wordsTLoad", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			wordsTFileBlock, 			/* parent widget */
			NULL 						/* argument list */
			);
	
	wordsTFilename = XtVaCreateManagedWidget(
			"wordsTFilename", 			/* widget name   */
			asciiTextWidgetClass, 		/* widget class */
			wordsTFileBlock, 			/* parent widget */
			XtNeditType, XawtextEdit,
			XtNtype, XawAsciiString,	
			NULL 						/* argument list */
			);
	
	wordsTFileSelect = XtVaCreateManagedWidget(
			"wordsTFileSelect", 			/* widget name */
			commandWidgetClass, 		/* widget class */
			wordsTFileBlock, 			/* parent widget */
			XtNbitmap, diskMark,
			NULL 						/* argument list */
			);
	
	wordsTEdit = XtVaCreateManagedWidget(
			"wordsTEdit", 				/* widget name   */
			asciiTextWidgetClass, 		/* widget class */
			wordsTextBlocks, 			/* parent widget */
			XtNeditType, XawtextEdit,
			XtNtype, XawAsciiString,	
			NULL 						/* argument list */
			);

	wordsTShellPopdown.popupWidget = popupButton;
	wordsTShellPopdown.popdownShell = wordsTextShell;
	XtAddCallback(popupButton, XtNcallback, anyWindowPopup, wordsTextShell);
	XtAddCallback(popupButton, XtNcallback, 
							XtCallbackExclusive, wordsTextShell);
	XtAddCallback(wordsTEnter, XtNcallback, WordsTEnter, NULL);
#ifndef	TEXTDISABLE
	XtAddCallback(wordsTLoad, XtNcallback, WordsTLoad, NULL);
	XtAddCallback(wordsTSave, XtNcallback, WordsTSave, NULL);
	XtSetSensitive(wordsTSave, ((app_data.read_only)?(False):(True)));
	XtAddCallback(wordsTFileSelect, XtNcallback, wordsTextSelector, NULL);
#else
	XtSetSensitive(wordsTFilename, False);
	XtSetSensitive(wordsTLoad, False);
	XtSetSensitive(wordsTSave, False);
	XtSetSensitive(wordsTFileSelect, False);
#endif	/*TEXTDISABLE*/
	VerifyShellInit(topLevel, cd_panel);
	XtAddCallback(wordsTPopdown, XtNcallback, WordsTPopdownSet, NULL);
	XtAddCallback(wordsTInit, XtNcallback, WordsTInitSet, NULL);
}

/***************************************************************************
 *	XmwCallbackNoneAutoHeight: 
 *	
 *		void XmwCallbackNoneAutoHeight(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsCallbackNoneAutoHeight(Widget w, XtPointer client_data, XtPointer call_data)
{
	XmwCallbackNoneAutoHeight(w, client_data, call_data);
	if(wordsListArray != NULL) {
		XtVaSetValues(wordsView, XtNallowVert, False, NULL);
		XawListChange(wordsList, wordsListArray, 
				arrayCount((XtPointer)printableWordList), 0, True);
		XtVaSetValues(wordsView, XtNallowVert, True, NULL);
		wordsListArray = NULL;
	}
}

/***************************************************************************
 *	WordsInit: ޥɡ˥塼ץࡦꥹȤνԤ
 *	
 *		void WordsInit(Widget topLevel, Widget cd_panel, Widget popupButton);
 *	
 *		Widget topLevel;
 *		Widget cd_panel;
 *		Widget popupButton;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void WordsInit(Widget topLevel, Widget cd_panel, Widget popupButton)
{
	Widget wordsFileSelect;
	int wordsMin;
	Boolean lockFlag;
	static PopdownInfo wordsShellPopdown;
	extern Pixmap getSize, maxLock;

	/***************************************
	 *	ףңĥǡδϢå
	 ***************************************/
	wordsShell = XtVaCreatePopupShell(
			"wordsShell",
			topLevelShellWidgetClass,
			topLevel,
			NULL
			);

	wordsBlocks = XtVaCreateManagedWidget(
			"wordsBlocks", 				/* widget name   */
			panedWidgetClass, 			/* widget class */
			wordsShell, 				/* parent widget*/
			NULL 						/* argument list*/
			);

	wordsFileBlock = XtVaCreateManagedWidget(
			"wordsFileBlock", 		/* widget name   */
			panedWidgetClass,	 	/* widget class */
			wordsBlocks, 				/* parent widget */
			XtNorientation, XtorientHorizontal,
			NULL 					/* argument list */
			);
	
	wordsPopdown = XtVaCreateManagedWidget(
			"wordsPopdown", 		/* widget name   */
			commandWidgetClass, 	/* widget class */
			wordsFileBlock, 		/* parent widget */
			NULL 					/* argument list */
			);
	
	wordsEditable = XtVaCreateManagedWidget(
			"wordsEditable", 			/* widget name   */
			toggleWidgetClass, 			/* widget class */
			wordsFileBlock, 			/* parent widget */
			NULL 						/* argument list */
			);
	
	
	wordsSave = XtVaCreateManagedWidget(
			"wordsSave", 		/* widget name   */
			commandWidgetClass, 	/* widget class */
			wordsFileBlock, 		/* parent widget */
			NULL 					/* argument list */
			);
	
	wordsLoad = XtVaCreateManagedWidget(
			"wordsLoad", 		/* widget name   */
			commandWidgetClass, 	/* widget class */
			wordsFileBlock, 		/* parent widget */
			NULL 					/* argument list */
			);
	
	wordsFilename = XtVaCreateManagedWidget(
			"wordsFilename", 			/* widget name   */
			asciiTextWidgetClass, 		/* widget class */
			wordsFileBlock, 			/* parent widget */
			XtNeditType, XawtextEdit,
			XtNtype, XawAsciiString,	
			NULL 						/* argument list */
			);
	
	wordsFileSelect = XtVaCreateManagedWidget(
			"wordsFileSelect", 			/* widget name */
			commandWidgetClass, 		/* widget class */
			wordsFileBlock, 			/* parent widget */
			XtNbitmap, diskMark,
			NULL 						/* argument list */
			);
	
	wordsEditBlock = XtVaCreateManagedWidget(
			"wordsEditBlock", 			/* widget name   */
			panedWidgetClass, 			/* widget class */
			wordsBlocks, 				/* parent widget*/
			XtNorientation, XtorientHorizontal,
			NULL 						/* argument list*/
			);

	wordsSetTiming = XtVaCreateManagedWidget(
			"wordsSetTiming", 			/* widget name   */
			commandWidgetClass, 		/* widget class */
			wordsEditBlock, 			/* parent widget */
			NULL 						/* argument list*/
			);

	wordsInsSpace = XtVaCreateManagedWidget(
			"wordsInsSpace", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			wordsEditBlock, 			/* parent widget */
			NULL 						/* argument list*/
			);

	wordsInsTiming = XtVaCreateManagedWidget(
			"wordsInsTiming", 			/* widget name   */
			commandWidgetClass, 		/* widget class */
			wordsEditBlock, 			/* parent widget */
			NULL 						/* argument list */
			);
	
	wordsDelTiming = XtVaCreateManagedWidget(
			"wordsDelTiming", 			/* widget name   */
			commandWidgetClass, 		/* widget class */
			wordsEditBlock, 			/* parent widget */
			NULL 						/* argument list */
			);
	
	wordsDecSec = XtVaCreateManagedWidget(
			"wordsDecSec", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			wordsEditBlock, 			/* parent widget */
			XtNbitmap, vdwDisablePixmap,
			NULL 						/* argument list*/
			);

	wordsIncSec = XtVaCreateManagedWidget(
			"wordsIncSec", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			wordsEditBlock, 			/* parent widget */
			XtNbitmap, vupDisablePixmap, 
			NULL 						/* argument list*/
			);

	wordsEdit = XtVaCreateManagedWidget(
			"wordsEdit", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			wordsEditBlock, 					/* parent widget */
			NULL 						/* argument list */
			);
	
	wordsFlashing = XtVaCreateManagedWidget(
			"wordsFlashing", 			/* widget name   */
			toggleWidgetClass, 			/* widget class */
			wordsEditBlock, 			/* parent widget */
			NULL 						/* argument list */
			);
	
	wordsSyncronize = XtVaCreateManagedWidget(
			"wordsSyncronize", 			/* widget name   */
			toggleWidgetClass, 			/* widget class */
			wordsEditBlock, 			/* parent widget */
			NULL 						/* argument list */
			);
	
	wordsUnselect = XtVaCreateManagedWidget(
			"wordsUnselect", 			/* widget name */
			toggleWidgetClass, 			/* widget class */
			wordsEditBlock, 			/* parent widget */
			NULL 						/* argument list */
			);

	wordsJump = XtVaCreateManagedWidget(
			"wordsJump", 				/* widget name */
			commandWidgetClass, 		/* widget class */
			wordsEditBlock, 			/* parent widget */
			NULL 						/* argument list */
			);


	wordsTrackBlock = XtVaCreateManagedWidget(
			"wordsTrackBlock", 			/* widget name   */
			panedWidgetClass, 			/* widget class */
			wordsBlocks, 				/* parent widget*/
			XtNorientation, XtorientHorizontal,
			NULL 						/* argument list*/
			);


	wordsTitle = XtVaCreateManagedWidget(
			"wordsTitle", 				/* widget name   */
			labelWidgetClass, 			/* widget class */
			wordsTrackBlock, 			/* parent widget */
			NULL 						/* argument list */
			);
	
	wordsSetMax = XtVaCreateManagedWidget(
				"wordsSetMax",
				commandWidgetClass,
				wordsTrackBlock,
				XtNbitmap, getSize, 
				NULL);

	wordsAllowResize = XtVaCreateManagedWidget(
				"wordsAllowResize",
				toggleWidgetClass,
				wordsTrackBlock,
				XtNbitmap, maxLock, 
				NULL);

	wordsDecTrack = XtVaCreateManagedWidget(
			"wordsDecTrack", 			/* widget name   */
			commandWidgetClass, 		/* widget class */
			wordsTrackBlock, 			/* parent widget */
			XtNbitmap, trackDecPixmap, 
			NULL 						/* argument list*/
			);

	wordsIncTrack = XtVaCreateManagedWidget(
			"wordsIncTrack", 			/* widget name */
			commandWidgetClass, 		/* widget class */
			wordsTrackBlock, 			/* parent widget */
			XtNbitmap, trackIncPixmap,
			NULL 						/* argument list */
			);

	wordsView = XtVaCreateManagedWidget(
			"wordsView", 				/* widget name   */
			viewportWidgetClass, 		/* widget class */
			wordsBlocks, 				/* parent widget */
			NULL 						/* argument list */
			);
	
	wordsList = XtVaCreateManagedWidget(
			"wordsList", 				/* widget name   */
			listWidgetClass, 			/* widget class */
			wordsView, 					/* parent widget */
			NULL 						/* argument list */
			);

	wordsShellPopdown.popupWidget = popupButton;
	wordsShellPopdown.popdownShell = wordsShell;

	XtAddCallback(popupButton, XtNcallback, WordsListPopup, cd_panel);
	/*XtAddCallback(popupButton, XtNcallback, XtCallbackNone, wordsShell);*/
	if(!app_data.wrdAutoHeight) {
		XtAddCallback(popupButton, XtNcallback, XtCallbackNone, wordsShell);
	} else {
		XtAddCallback(popupButton, XtNcallback, 
										WordsCallbackNoneAutoHeight, wordsView);
	}
	XtAddCallback(wordsPopdown, XtNcallback, 
								PopdownTargetShell, &wordsShellPopdown);
	XtAddCallback(wordsPopdown, XtNcallback, WordsPopdown, NULL);
	XtAddCallback(wordsEditable, XtNcallback, WordsEditable, NULL);
	WordsEditable(wordsEditable, NULL, NULL);
	XtAddCallback(wordsSetTiming, XtNcallback, WordsTimeSet, NULL);
	XtAddCallback(wordsInsSpace, XtNcallback, WordsInsSpace, NULL);
	XtAddCallback(wordsDecSec, XtNcallback, WordsDecSec, NULL);
 	XtAddCallback(wordsIncSec, XtNcallback, WordsIncSec, NULL);
	XtAddCallback(wordsSetMax, XtNcallback, WordsSetMaxHeight, NULL);
	XtAddCallback(wordsAllowResize , XtNcallback, WordsMaxLock, NULL);
	XtAddCallback(wordsDecTrack, XtNcallback, WordsTrackDec, NULL);
 	XtAddCallback(wordsIncTrack, XtNcallback, WordsTrackInc, NULL);
 	XtAddCallback(wordsInsTiming, XtNcallback, WordsTimeIns, NULL);
 	XtAddCallback(wordsDelTiming, XtNcallback, WordsTimeDel, NULL);
	XtAddCallback(wordsList, XtNcallback, WordsSelect, NULL);
	XtAddCallback(wordsView, XtNreportCallback, WordsGeometry, NULL);
	XtAddCallback(wordsUnselect, XtNcallback, WordsUnselect, NULL);
	XtAddCallback(wordsJump, XtNcallback, WordsJump, NULL);
	XtAddCallback(wordsLoad, XtNcallback, WordsLoad, NULL);
	XtAddCallback(wordsSave, XtNcallback, WordsSave, NULL);
	XtAddCallback(wordsFileSelect, XtNcallback, wordsWindowSelector, NULL);
	XtAddCallback(wordsEdit, XtNcallback, WordsEdit, NULL);
	WordsEditInit(topLevel, wordsPopdown, wordsEdit);
	XawPanedGetMinMax(wordsView, &wordsMin, &wordsHeight);
	XtVaGetValues(wordsAllowResize, XtNstate, &lockFlag, NULL);
	if(lockFlag == False) {
		XawPanedSetMinMax(wordsView, 1, ~0);
	}
}

#ifdef RESIZE_TEST
/***************************************************************************
 *	ResizeConfig: λɽʤΥĴ륢
 *	
 *		void ResizeConfig(Widget w, XEvent *event, String *params, Cardinal *num_params);
 *	
 *		Widget w;					̤
 *		XEvent *event;				̤
 *		String *params;				̤
 *		Cardinal *num_params;		̤
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void ResizeConfig(Widget w, XEvent *event, String *params, Cardinal *num_params)
{
	Widget target = NULL;
	Boolean flag;
	XrmValue from, to;
	extern Widget topLevel;
	Display *display = NULL;
	Window event_id, window_id;
	Widget event_w,  window_w;
	String name;
	int min, max;

	switch(event->type) {
	default:	/* ΰ¿Ȥ */
		break;
	case ConfigureNotify:		/* ConfigureNotify  */
		if(wordsHeight == EOF) {
			printf(">>wordsView : min = %d, max = %d.\n", 1, event->xconfigure.height);
			/*XawPanedSetMinMax(wordsView, 1, event->xconfigure.height);*/
		}
		XawPanedGetMinMax(wordsView, &min, &max);
		printf(">wordsView : min = %d, max = %d(%d).\n", min, max, event->xconfigure.height);
		printf(">wordsList : height = %d.\n", wordsHeight);
		break;
	}
}

/***************************************************************************
 *	ResizeConfig: λɽʤΥĴ륢
 *	
 *		void ResizeConfig(Widget w, XEvent *event, String *params, Cardinal *num_params);
 *	
 *		Widget w;					̤
 *		XEvent *event;				̤
 *		String *params;				̤
 *		Cardinal *num_params;		̤
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void ResizeConfig(Widget w, XEvent *event, String *params, Cardinal *num_params)
{
	Widget target = NULL;
	Boolean flag;
	XrmValue from, to;
	extern Widget topLevel;
	Display *display = NULL;
	Window event_id, window_id;
	Widget event_w,  window_w;
	String name;

	switch(event->type) {
	default:	/* ΰ¿Ȥ */
		XtWarning("This event is not supportted.");
		break;
	case ConfigureNotify:		/* ResizeRequest  */
		printf("<%s> ConfigureNotify:%dx%d Window %u\n", 
				XtName(w), event->xconfigure.width, 
				event->xconfigure.height, event->xconfigure.window);
		break;
	case ConfigureRequest:		/* ResizeRequest  */
		printf("<%s> ConfigureRequest:%dx%d Window %u\n", 
				XtName(w), event->xconfigurerequest.width, 
				event->xconfigurerequest.height, event->xconfigurerequest.window);
		break;
	case ResizeRequest:		/* ResizeRequest  */
		printf("<%s> ResizeRequest:%dx%d Window %u\n", 
				XtName(w), event->xresizerequest.width, 
				event->xresizerequest.height, event->xresizerequest.window);
		break;
	case Expose:		/* Expose  */
		printf("<%s> Expose:%dx%d Window %u\n", 
				XtName(w), event->xexpose.width, 
				event->xexpose.height, event->xexpose.window);
		break;
	}
}
#endif /*RESIZE_TEST*/

